
/*  A Bison parser, made from control.y  */

#define	WORD	258
#define	STRING	259
#define	FLOAT	260
#define	INTEGER	261
#define	ABORT	262
#define	APROPOS	263
#define	CHDIR	264
#define	DEFINE	265
#define	DELETE	266
#define	DO	267
#define	EDIT	268
#define	ELSE	269
#define	FOREACH	270
#define	HELP	271
#define	HISTORY	272
#define	IF	273
#define	KEY	274
#define	LIST	275
#define	MACRO	276
#define	OVERLOAD	277
#define	PRINT	278
#define	PROMPT	279
#define	QUIT	280
#define	READ	281
#define	RESTORE	282
#define	SAVE	283
#define	SET	284
#define	SNARK	285
#define	STANDARD	286
#define	TERMTYPE	287
#define	VERBOSE	288
#define	VERSION	289
#define	WRITE	290
#define	ANGLE	291
#define	ASPECT	292
#define	AXIS	293
#define	BOX	294
#define	CONNECT	295
#define	CONTOUR	296
#define	CTYPE	297
#define	CURSOR	298
#define	DATA	299
#define	DEVICE	300
#define	DOT	301
#define	DRAW	302
#define	ERASE	303
#define	ERRORBAR	304
#define	EXPAND	305
#define	FORMAT	306
#define	GRID	307
#define	HISTOGRAM	308
#define	IMAGE	309
#define	LABEL	310
#define	LEVELS	311
#define	LIMITS	312
#define	LINES	313
#define	LOCATION	314
#define	LTYPE	315
#define	LWEIGHT	316
#define	MINMAX	317
#define	NOTATION	318
#define	PAGE	319
#define	POINTS	320
#define	PTYPE	321
#define	PUTLABEL	322
#define	RANGE	323
#define	RELOCATE	324
#define	RETURN	325
#define	SHADE	326
#define	SORT	327
#define	SPLINE	328
#define	SURFACE	329
#define	TICKSIZE	330
#define	USER	331
#define	VIEWPOINT	332
#define	WHATIS	333
#define	WINDOW	334
#define	XLABEL	335
#define	YLABEL	336
#define	META	337
#define	OLD	338
#define	ROW	339
#define	ABS	340
#define	ACOS	341
#define	ASIN	342
#define	ATAN	343
#define	ATAN2	344
#define	CONCAT	345
#define	COS	346
#define	DIMEN	347
#define	EXP	348
#define	FFT	349
#define	INT	350
#define	LG	351
#define	LN	352
#define	PI	353
#define	RANDOM	354
#define	SIN	355
#define	SQRT	356
#define	SUM	357
#define	TAN	358
#define	POWER_SYMBOL	359
#define	INDEX	360
#define	LENGTH	361
#define	SPRINTF	362
#define	STRLEN	363
#define	SUBSTR	364
#define	UNARY	365

/* #line 1 "control.y" */

#  include "copyright.h"
#  include "options.h"
#  include <math.h>
#  include <stdio.h>
#  include <ctype.h>
#ifndef INTEGER
#  include "control.h"
#endif
#  include "stack.h"
#  include "vectors.h"
#  include "yaccun.h"
#  include "devices.h"
#  include "sm_declare.h"
#  if defined(_IBMR2)
#     pragma alloca
#  endif

#define bcopy(S1,S2,N) memcpy(S2,S1,N)	/* use memcpy instead */
#define MACROSIZE 2000		/* longest allowed DO FOREACH IF list */
#define Pi 3.141592653589793238
#ifndef YYIMPURE			/* a bison bug -- yydebug isn't */
   static int yydebug = 0;		/* declared for pure parsers */
#endif
/*
 * And some variables of my own:
 * The Auto Variables get moved into yyparse and made auto when control.y
 * is built (under unix, that is. Under vms, this won't happen).
 */
   static char data_file[CHARMAX]; /* name of current data file */
   extern char prompt[],	/* system prompt */
               user_name[];	/* name of user of programme */
   extern FILE *logfil;		/* where to log all terminal input */
   static float x_range = 0,	/* Ranges for the x */
		y_range = 0;	/* and y axes */
   static int in_graphics = 0,	/* are graphics active? */
              graph_mode,	/* terminal is set to graph mode */
	      line_1,line_2;	/* line numbers to use in data_file */
   extern int in_quote,		/* am I in a quoted string? */
   	      sm_interrupt,	/* do you want to interrupt something ? */
   	      noexpand,		/* expand @#$ ? */
	      plength,		/* number of printing chars in prompt */
	      recurse_lvl,	/* how deeply nested are we? */
   	      sm_verbose;		/* produce lots of output */
/*
  This grammar generates 13 Shift/Reduce and 2 Reduce/Reduce conflicts.
  They are (approximately; state numbers may vary):
State 8 contains 2 shift/reduce conflicts.	DELETE . HISTORY/WORD ...
State 23 contains 1 shift/reduce conflicts.	RESTORE . word_or_space
State 24 contains 1 shift/reduce conflicts.	SAVE . word_or_space
State 135 contains 2 reduce/reduce conflicts.   '-' . expr
State 137 contains 1 shift/reduce conflict.	ANGLE expr . '!' ...
State 141 contains 1 shift/reduce conflict.	expr . '!' ...
State 146 contains 1 shift/reduce conflict.	EXPAND expr . '!' ...
State 154 contains 1 shift/reduce conflict.	LEVELS expr . '!' ...
State 186 contains 2 shift/reduce conflicts.	GRID . integer_or_space ...
State 334 contains 1 shift/reduce conflict.	SURFACE INTEGER .
State 364 contains 1 shift/reduce conflict.	SET word = expr . [ IF ... ]
State 437 contains 1 shift/reduce conflict.	plot pexpr pexpr . [ IF ... ]
 */

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#define	YYACCEPT	return(0)
#define	YYABORT	return(1)
#define	YYERROR	return(1)
#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>



#define	YYFINAL		592
#define	YYFLAG		-32768
#define	YYNTBASE	131

#define YYTRANSLATE(x) (yytranslate[x])

static short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   123,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   115,     2,     2,     2,     2,   113,     2,   124,
   125,   120,   118,   126,   119,     2,   121,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   111,     2,   116,
   114,   117,   110,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   129,     2,   130,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   127,   112,   128,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   122
};

static short yyrline[] = {     0,
   115,   123,   126,   138,   154,   167,   172,   178,   180,   205,
   218,   225,   229,   239,   249,   251,   264,   299,   311,   326,
   328,   333,   335,   337,   339,   341,   343,   345,   347,   366,
   374,   396,   408,   409,   410,   431,   436,   469,   486,   488,
   493,   498,   499,   530,   532,   534,   544,   567,   574,   576,
   581,   583,   585,   587,   604,   616,   618,   625,   630,   632,
   634,   636,   641,   643,   645,   647,   655,   663,   665,   667,
   669,   680,   682,   697,   699,   701,   711,   713,   715,   754,
   767,   774,   794,   803,   815,   821,   826,   828,   830,   842,
   855,   949,   981,   983,   985,   987,  1006,  1012,  1014,  1016,
  1018,  1047,  1077,  1087,  1106,  1198,  1200,  1202,  1204,  1214,
  1216,  1218,  1220,  1249,  1251,  1256,  1282,  1289,  1296,  1309,
  1324,  1353,  1355,  1361,  1369,  1410,  1453,  1455,  1462,  1464,
  1466,  1468,  1470,  1472,  1474,  1476,  1478,  1480,  1482,  1484,
  1486,  1488,  1490,  1497,  1499,  1501,  1503,  1505,  1507,  1509,
  1511,  1513,  1515,  1517,  1519,  1521,  1523,  1525,  1527,  1529,
  1531,  1533,  1535,  1537,  1539,  1541,  1543,  1547,  1549,  1553,
  1555,  1559,  1561,  1565,  1567,  1571,  1574,  1576,  1595,  1597,
  1599,  1601,  1603,  1608,  1610,  1612,  1617,  1619,  1621,  1623,
  1625,  1627,  1666,  1668,  1676,  1678,  1680,  1682,  1707,  1739,
  1747,  1749,  1751,  1769,  1771,  1791,  1804,  1811,  1819,  1829,
  1831,  1835,  1837,  1841,  1887,  1895,  1897,  1910,  1923,  1938,
  1940,  1942,  1944,  1956,  1983,  1985,  1989,  1991,  1995,  2006,
  2010,  2012,  2014,  2018,  2020,  2024,  2031,  2035,  2037,  2039,
  2043,  2061,  2090,  2151,  2179,  2181,  2185,  2214,  2216
};

static char * yytname[] = {     0,
"error","$illegal.","WORD","STRING","FLOAT","INTEGER","ABORT","APROPOS","CHDIR","DEFINE",
"DELETE","DO","EDIT","ELSE","FOREACH","HELP","HISTORY","IF","KEY","LIST",
"MACRO","OVERLOAD","PRINT","PROMPT","QUIT","READ","RESTORE","SAVE","SET","SNARK",
"STANDARD","TERMTYPE","VERBOSE","VERSION","WRITE","ANGLE","ASPECT","AXIS","BOX","CONNECT",
"CONTOUR","CTYPE","CURSOR","DATA","DEVICE","DOT","DRAW","ERASE","ERRORBAR","EXPAND",
"FORMAT","GRID","HISTOGRAM","IMAGE","LABEL","LEVELS","LIMITS","LINES","LOCATION","LTYPE",
"LWEIGHT","MINMAX","NOTATION","PAGE","POINTS","PTYPE","PUTLABEL","RANGE","RELOCATE","RETURN",
"SHADE","SORT","SPLINE","SURFACE","TICKSIZE","USER","VIEWPOINT","WHATIS","WINDOW","XLABEL",
"YLABEL","META","OLD","ROW","ABS","ACOS","ASIN","ATAN","ATAN2","CONCAT",
"COS","DIMEN","EXP","FFT","INT","LG","LN","PI","RANDOM","SIN",
"SQRT","SUM","TAN","POWER_SYMBOL","INDEX","LENGTH","SPRINTF","STRLEN","SUBSTR","'?'",
"':'","'|'","'&'","'='","'!'","'<'","'>'","'+'","'-'","'*'",
"'/'","UNARY","'\\n'","'('","')'","','","'{'","'}'","'['","']'",
"line"
};

static short yyr1[] = {     0,
   131,   131,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   133,   132,   132,   132,   132,   132,   132,   132,
   134,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   135,   135,   135,   135,
   136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
   136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
   136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
   136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
   136,   136,   136,   136,   136,   136,   136,   137,   137,   138,
   138,   139,   139,   140,   140,   141,   141,   141,   141,   141,
   141,   141,   141,   141,   141,   141,   141,   141,   141,   141,
   141,   141,   141,   141,   141,   141,   141,   141,   141,   141,
   141,   141,   141,   141,   141,   141,   141,   141,   141,   142,
   142,   143,   143,   144,   144,   145,   145,   145,   145,   146,
   146,   146,   146,   146,   147,   147,   148,   148,   149,   149,
   150,   150,   150,   151,   151,   152,   152,   153,   153,   153,
   154,   155,   156,   157,   158,   158,   159,   160,   160
};

static short yyr2[] = {     0,
     0,     2,     1,     1,     1,     2,     1,     2,     2,     2,
     3,     3,     4,     5,     3,     3,     4,     3,     5,     3,
     1,     2,     3,     2,     3,     3,     4,     2,     2,     3,
     2,    10,     0,     3,     1,     2,     6,     6,     3,     2,
     0,     2,     1,     1,     2,     8,    11,     2,     2,     2,
     6,     6,    10,     2,     3,     1,     3,     3,     4,     2,
     2,     3,     4,     2,     5,     2,     4,     3,     4,     3,
     3,     3,     4,     5,     3,     3,     5,     3,     5,     1,
     3,     2,     4,     2,     1,     3,     3,     4,     4,     3,
     2,     3,     2,     1,     2,     7,     3,     9,     3,     4,
     8,     7,     7,     1,     2,     5,     5,     3,     2,     1,
     4,     5,     1,     3,     2,     3,     1,     1,     3,     3,
     1,     3,     1,     1,     4,     4,     3,     2,     5,     4,
     4,     4,     4,     6,     4,     4,     3,     3,     3,     3,
     3,     4,     2,     4,     4,     4,     3,     4,     3,     4,
     6,     6,     6,     4,     4,     4,     4,     1,     1,     4,
     4,     6,     4,     4,     4,     8,     4,     3,     3,     3,
     3,     1,     2,     3,     1,    10,    10,    11,     1,     3,
     5,     1,     3,     2,     2,     2,     3,     1,     3,     5,
     1,     5,     3,     1,     2,     2,     1,     3,     7,     2,
     3,     5,     4,     4,     6,     2,     2,     1,     1,     1,
     2,     1,     0,     1,     2,     0,     2,     2,     2,     2,
     2,     4,     4,     4,     1,     1,     0,     2,     1,     3,
     1,     1,     1,     1,     0,     0,     1,     1,     1,     0,
     1,     0,     0,     1,     0,     1,     0,     0,     1
};

static short yydefact[] = {     1,
     0,    35,   113,     5,     7,     0,   247,    21,   247,    33,
   247,    43,    44,     0,    56,     0,     0,   247,   235,    80,
    85,     0,   248,   248,     0,   104,     0,   240,   110,   235,
   240,   240,     0,     0,   240,   240,     0,   240,   240,     0,
     0,   240,     0,   240,     0,   240,    94,     0,     0,   240,
   240,   240,     0,   240,     4,     3,     2,     0,     9,   240,
    28,   210,    24,     0,    22,     0,   242,     0,    45,   240,
     0,    61,     0,    64,    60,   213,     0,     0,     0,     0,
     0,   234,   248,   240,   244,     0,     0,     0,   216,   216,
    91,     0,   249,    93,    95,     0,     0,     0,     0,   240,
   213,     0,     0,     0,   239,   238,   109,     0,     0,   115,
     0,   123,   244,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   159,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   240,   238,   240,     6,   121,
   158,   124,   241,     8,    10,    31,    29,     0,    36,   226,
    40,   225,   240,    50,    49,    48,     0,    54,   229,   240,
   240,   240,   214,     0,     0,    66,     0,   240,    82,     0,
   240,    84,   240,   105,     0,   240,   240,   240,     0,     0,
   240,   179,   231,   182,     0,     0,   188,   240,   191,     0,
   213,   232,   194,   240,   197,   233,     0,   240,   172,     0,
     0,   208,   209,     0,    42,     0,    20,     0,    12,   236,
    16,    18,   243,   240,   243,    11,    15,    25,    26,   211,
    23,   240,    34,   216,   175,     0,     0,     0,    58,     0,
    62,    68,   212,     0,    72,    70,    71,   235,    78,   245,
    90,    87,     0,   240,   240,   240,    92,   240,   240,    97,
   240,     0,    99,   212,   108,   242,   240,   240,   220,   221,
   114,   116,   240,   240,   240,   240,   240,   240,   240,   240,
   240,   240,   240,   240,   240,   240,   240,   240,   240,   240,
   240,   240,   240,   240,   240,   240,   143,   128,     0,   240,
   240,   240,     0,     0,     0,     0,   240,   240,   240,   240,
   240,   240,    30,    39,   240,     0,     0,    55,   215,    57,
     0,    76,   240,    81,     0,    86,     0,   240,   240,   240,
    75,     0,   240,     0,   185,   184,   240,     0,   186,   240,
   240,     0,   213,   196,   195,   200,   240,   240,   173,   240,
   206,   207,     0,     0,    13,   237,    17,     0,     0,     0,
    27,     0,   240,   243,     0,    59,    63,    69,    67,    73,
     0,   246,     0,    88,    89,   168,   219,   217,   218,   169,
   100,     0,     0,     0,     0,     0,     0,     0,   118,     0,
   117,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   127,   122,   141,     0,   240,   240,
   240,   240,   240,   149,   240,   147,   137,   138,   139,   140,
   240,     0,   230,     0,   240,    83,     0,   240,   111,   240,
     0,   240,   180,   183,   187,   240,   189,   240,   193,   240,
   201,   240,     0,   198,    14,   170,    19,   171,   240,   174,
     0,   243,    74,    79,     0,   240,     0,   240,     0,   224,
   222,   223,   125,   240,   126,   164,   240,   240,   130,   131,
   132,   133,   240,   135,   136,   154,   156,   157,   160,   161,
   163,   167,   240,   155,   240,   165,   240,   240,   146,   145,
   142,   144,   150,   148,   240,     0,    65,    77,   106,   107,
   112,     0,   240,     0,     0,     0,     0,     0,   204,   203,
     0,   227,    38,     0,   240,   227,   240,     0,   240,   119,
   120,     0,     0,     0,     0,     0,     0,   129,    51,    52,
    37,     0,     0,   181,   190,   192,   202,     0,   240,   240,
     0,     0,     0,   102,   103,     0,    96,   151,   152,   134,
   153,   162,   240,   240,     0,     0,     0,   205,     0,   228,
   243,     0,    46,   101,   240,     0,   240,     0,     0,     0,
   199,     0,   243,    98,   166,   240,     0,     0,     0,    32,
     0,    53,     0,     0,     0,    47,   176,     0,   177,   178,
     0,     0
};

static short yydefgoto[] = {     1,
    57,    67,    58,   380,   143,   140,   216,   204,   226,   205,
   254,   234,   161,   245,   141,   368,   541,   163,   206,    83,
   347,   108,   144,   223,   348,   142,   363,    60,    94
};

static short yypact[] = {-32768,
   787,-32768,-32768,-32768,-32768,    50,-32768,    73,-32768,-32768,
-32768,-32768,   -48,   -41,-32768,   249,   220,-32768,   -26,-32768,
-32768,    46,   103,   103,   212,-32768,   109,   130,-32768,    72,
   665,   665,   111,    39,   665,   149,    22,   665,    85,   112,
   116,   130,   120,   130,    51,   130,-32768,   -54,   121,   130,
   130,   130,   145,   130,-32768,-32768,-32768,   844,-32768,   398,
-32768,-32768,    23,   168,    42,    67,-32768,   -19,-32768,   665,
    16,-32768,    28,-32768,-32768,    24,   179,   180,   185,   190,
    42,-32768,   103,   169,-32768,   196,   209,   211,-32768,-32768,
-32768,   -54,-32768,-32768,-32768,   -74,   218,   102,   113,   130,
    42,   114,   118,   119,-32768,-32768,-32768,    93,   241,-32768,
   247,   -61,   128,   132,   133,   134,   140,   141,   152,   157,
   158,   172,   174,   181,   184,-32768,   189,   195,   204,   205,
   206,   223,   233,   238,   240,   665,   665,   665,  1542,-32768,
-32768,-32768,  1542,-32768,-32768,-32768,-32768,   266,  1542,-32768,
-32768,-32768,   169,   385,-32768,-32768,   267,  1542,-32768,   665,
    85,   130,-32768,   308,   366,-32768,   370,   130,-32768,   368,
   665,-32768,   130,-32768,   373,   130,   130,   130,   374,     7,
   130,   372,-32768,-32768,    33,    34,-32768,   182,-32768,     7,
    42,-32768,-32768,   197,-32768,-32768,   376,   287,   327,    42,
    40,-32768,-32768,   377,-32768,     7,-32768,   378,-32768,   -49,
-32768,-32768,-32768,   665,-32768,-32768,-32768,-32768,    42,-32768,
-32768,   665,-32768,-32768,-32768,   258,   261,   384,-32768,   389,
-32768,-32768,    42,   -49,-32768,-32768,-32768,   -27,-32768,   390,
-32768,-32768,   392,   169,    77,     9,-32768,   665,   665,-32768,
   665,   395,-32768,-32768,-32768,-32768,   665,   665,-32768,-32768,
-32768,-32768,    17,   665,   665,   665,   665,   665,   665,   665,
   665,   665,   665,   665,   665,   665,   665,   665,   665,   665,
   665,   665,   665,   665,   665,   665,   295,   295,   965,   665,
   665,   665,   298,   294,   302,   307,   540,   597,   665,   665,
   665,   665,-32768,-32768,   130,   296,   984,-32768,-32768,-32768,
   407,-32768,   130,-32768,  1002,-32768,   420,   130,   130,   130,
-32768,     7,   130,   419,-32768,-32768,   665,   423,-32768,   130,
   130,     7,    42,-32768,-32768,-32768,   130,   130,-32768,   130,
-32768,-32768,     7,     7,   421,-32768,-32768,   311,  1020,   304,
-32768,   321,    66,-32768,   303,-32768,-32768,-32768,-32768,-32768,
   430,-32768,   -54,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   451,   322,   618,   836,   309,   324,  1038,  1056,-32768,    -9,
-32768,   817,  1074,  1506,   854,  1092,  1110,  1128,  1146,   873,
  1164,  1182,  1200,  1218,  1236,   326,  1254,  1272,  1290,   891,
  1308,   910,  1326,   928,-32768,   299,-32768,  1524,   665,   665,
   665,   665,   665,   203,   665,   203,   -46,   -46,   295,   295,
   130,   444,-32768,   447,   130,-32768,   452,   130,-32768,   130,
   453,    85,   448,   493,-32768,   130,-32768,   665,-32768,   130,
-32768,   130,     7,   439,-32768,-32768,-32768,-32768,   665,-32768,
   330,-32768,-32768,-32768,   335,   665,   346,   665,   347,-32768,
-32768,-32768,-32768,   161,-32768,-32768,   665,   665,-32768,-32768,
-32768,-32768,   665,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   665,-32768,   665,-32768,   665,   665,  1560,  1578,
   203,   203,   203,   203,   130,   337,-32768,-32768,-32768,-32768,
-32768,   461,   130,     7,   459,   341,   325,   343,   467,-32768,
   349,   345,-32768,   355,   665,   345,   665,  1344,   169,-32768,
-32768,  1362,  1380,  1398,  1416,  1434,   947,  1542,-32768,   385,
-32768,   468,   107,-32768,-32768,-32768,-32768,   482,   665,   665,
   361,    -8,  1452,-32768,   493,   375,-32768,-32768,-32768,-32768,
-32768,-32768,   665,   130,   486,   487,   488,-32768,  1470,-32768,
-32768,   369,-32768,-32768,   665,  1488,   130,   489,   491,   492,
-32768,   371,-32768,   493,-32768,   130,   495,   499,   500,-32768,
   383,-32768,   506,   507,   509,-32768,-32768,   512,-32768,-32768,
   519,-32768
};

static short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,    69,    -7,  -182,-32768,-32768,-32768,
     1,   -97,   359,   -83,   -28,   -33,     5,  -146,-32768,   -25,
-32768,-32768,   -68,   268,  -198,   -21,-32768,    75,    19
};


#define	YYLAST		1699


static short yytable[] = {   107,
    92,   227,   153,   255,   111,   562,   246,   152,    65,   159,
   162,   150,    85,   166,    91,   168,   350,   173,   228,   150,
   379,   176,   177,   178,   154,   180,   217,   346,    62,    62,
   230,   152,   155,   322,   232,   325,   328,   172,   326,   248,
   174,   146,    95,   332,   147,    62,   341,    62,    84,    85,
   241,   359,    59,   169,   249,   152,   170,   291,    86,   344,
   225,    89,   263,   219,   156,   221,   213,   264,   150,    85,
    69,   253,    90,   301,   302,    61,   233,   215,    62,   150,
    85,   239,    70,    66,   247,    68,   102,   159,   109,    63,
    82,    82,    81,   333,   102,   360,    89,   259,   260,   139,
   103,   240,   110,   149,   224,    93,   158,    90,   103,   556,
   104,   101,   557,   145,   563,   463,   464,   164,   104,   304,
   148,   165,   167,   175,   152,   305,   105,   106,    87,    88,
   160,   367,   162,   309,   105,   106,   370,   218,   229,   313,
   353,    64,    64,   102,   316,   157,   327,   318,   319,   320,
   231,   150,   323,   352,   102,   451,   329,   103,    64,   331,
    64,    89,   102,   150,   520,   335,    89,   104,   103,   338,
   179,   150,    90,   220,   171,   431,   103,    90,   104,   372,
   222,   235,   236,   105,   106,   438,   104,   237,   367,    82,
   450,    64,   238,   366,   105,   106,   443,   444,   242,   367,
   340,   342,   105,   106,   287,   288,   289,   102,   160,   396,
   365,   243,   361,   244,    96,   152,   152,   152,   362,   351,
   250,   103,    76,   369,   369,   251,   102,    97,   307,   381,
    77,   104,    78,   358,   152,   439,   252,   256,   102,   315,
   103,   257,   258,   261,   334,    79,   102,   105,   106,   262,
   104,   265,   103,   514,    80,   266,   267,   268,    71,   102,
   103,    72,   104,   269,   270,    98,   105,   106,   303,    73,
   104,   151,   306,   103,   102,   271,   421,    74,   105,   106,
   272,   273,   349,   104,   425,   504,   105,   106,   103,   428,
   429,   430,   290,    75,   432,   274,   510,   275,   104,   105,
   106,   436,   437,    99,   276,   330,   291,   277,   440,   441,
   100,   442,   278,   310,   105,   106,   371,   373,   279,   374,
   299,   300,   301,   302,   152,   377,   378,   280,   281,   282,
   536,   369,   382,   383,   384,   385,   386,   387,   388,   389,
   390,   391,   392,   393,   394,   395,   283,   397,   398,   399,
   400,   401,   402,   403,   404,   454,   284,   533,   406,   407,
   408,   285,   572,   286,   102,   414,   416,   417,   418,   419,
   420,   311,   312,   314,   581,   317,   321,   324,   103,   339,
   512,   336,   343,   345,   354,   355,   356,   516,   104,  -240,
  -240,   357,   495,    85,   364,   434,   498,   375,   291,   500,
   150,   501,   291,   503,   105,   106,   410,   506,   207,   409,
   337,   508,   424,   509,   290,   411,   299,   300,   301,   302,
   412,   422,   427,   208,   433,   435,   445,   446,   291,   452,
   521,   448,   453,   459,   292,   152,   293,   294,   295,   296,
   297,   298,   299,   300,   301,   302,   449,   456,   460,   496,
   479,   209,   497,   505,   499,   502,   511,   513,   515,   517,
   519,   530,   102,   531,   534,   535,   529,   537,   455,   538,
   540,   560,   539,   555,   532,   102,   103,   489,   490,   491,
   492,   493,   542,   494,   558,   547,   104,   561,   565,   103,
   152,   568,   569,   570,   577,   573,   578,   579,   580,   104,
   583,   554,   105,   106,   584,   585,   507,   210,   211,   212,
   586,   587,   588,   213,   589,   105,   106,   590,   592,   308,
   544,   214,     0,   376,   215,   567,   518,     0,     0,     0,
     0,     0,     0,     0,     0,   522,   523,     0,   576,     0,
   290,   524,   112,   113,     0,     0,     0,   582,     0,     0,
     0,   525,     0,   526,   291,   527,   528,     0,     0,     0,
   292,     0,   293,   294,   295,     0,   297,   298,   299,   300,
   301,   302,     0,     0,     0,     0,  -241,     0,     0,     0,
     0,     0,   290,   543,     0,   545,     0,     0,     0,     0,
     0,     0,   114,   115,     0,     0,   291,     0,     0,   112,
   113,     0,   292,     0,   293,   294,   295,   559,   297,   298,
   299,   300,   301,   302,     0,     0,     0,   102,     0,     0,
     0,   566,     0,     0,   116,   117,   118,   119,   120,     0,
   121,   103,   122,   574,   123,   124,   125,   126,   127,   128,
   129,   104,   130,     0,   131,   132,   133,   134,   135,   114,
   115,     0,     0,   413,   136,    89,     0,   105,   137,     0,
     0,     0,     0,   138,     0,     0,    90,   112,   113,     0,
     0,     0,     0,     0,   102,     0,     0,     0,     0,     0,
     0,   116,   117,   118,   119,   120,     0,   121,   103,   122,
     0,   123,   124,   125,   126,   127,   128,   129,   104,   130,
     0,   131,   132,   133,   134,   135,     0,   290,     0,     0,
   415,   136,    89,     0,   105,   137,     0,   114,   115,     0,
   138,   291,     0,    90,     0,     0,     0,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,     0,
     0,     0,   102,     0,     0,     0,     0,   457,     0,   116,
   117,   118,   119,   120,     0,   121,   103,   122,     0,   123,
   124,   125,   126,   127,   128,   129,   104,   130,     0,   131,
   132,   133,   134,   135,     0,     0,     0,     0,     0,   136,
    89,     0,   105,   137,     0,     0,   591,     2,   138,     3,
     0,    90,     0,     4,     5,     6,     7,     8,     9,    10,
     0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,     0,    27,    28,
    29,    30,    31,    32,   -41,   -41,   -41,   -41,   -41,   -41,
    33,    34,   -41,   -41,   -41,   -41,    35,    36,   -41,   -41,
    37,   -41,    38,    39,    40,    41,   -41,    42,    43,    44,
   -41,   -41,    45,   -41,    46,   -41,    47,   -41,    48,    49,
   -41,    50,   -41,    51,     0,    52,   -41,   -41,    53,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    54,   181,   182,   183,   184,   185,   186,     0,     0,   187,
   188,   189,   190,     0,     0,   191,   192,     0,   193,     0,
     0,    55,     0,   194,     0,     0,   290,   195,   196,    56,
   197,     0,   198,     0,   199,     0,     0,   200,     0,   201,
   291,     0,     0,   202,   203,   290,   292,     0,   293,   294,
   295,   296,   297,   298,   299,   300,   301,   302,     0,   291,
     0,     0,     0,   290,     0,   292,   465,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   291,     0,     0,
     0,   458,   290,   292,     0,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,     0,   291,     0,     0,   468,
   290,     0,   292,     0,   293,   294,   295,   296,   297,   298,
   299,   300,   301,   302,   291,     0,     0,     0,   473,   290,
   292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
   301,   302,     0,   291,     0,     0,   483,   290,     0,   292,
     0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,     0,   485,   290,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,     0,
   291,     0,     0,   487,   290,     0,   292,     0,   293,   294,
   295,   296,   297,   298,   299,   300,   301,   302,   291,     0,
     0,     0,   553,   290,   292,     0,   293,   294,   295,   296,
   297,   298,   299,   300,   301,   302,     0,   291,     0,   405,
     0,   290,     0,   292,     0,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   291,     0,     0,   423,   290,
     0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   302,   291,     0,     0,   426,   290,     0,   292,
     0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,   447,   290,     0,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,   291,
     0,     0,   461,   290,     0,   292,     0,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   291,     0,     0,
   462,   290,     0,   292,     0,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   291,     0,     0,   466,   290,
     0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   302,   291,     0,     0,   469,   290,     0,   292,
     0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,   470,   290,     0,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,   291,
     0,     0,   471,   290,     0,   292,     0,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   291,     0,     0,
   472,   290,     0,   292,     0,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   291,     0,     0,   474,   290,
     0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   302,   291,     0,     0,   475,   290,     0,   292,
     0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,   476,   290,     0,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,   291,
     0,     0,   477,   290,     0,   292,     0,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   291,     0,     0,
   478,   290,     0,   292,     0,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   291,     0,     0,   480,   290,
     0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   302,   291,     0,     0,   481,   290,     0,   292,
     0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,   482,   290,     0,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,   291,
     0,     0,   484,   290,     0,   292,     0,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   291,     0,     0,
   486,   290,     0,   292,     0,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   291,     0,     0,   546,   290,
     0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   302,   291,     0,     0,   548,   290,     0,   292,
     0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,   549,   290,     0,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,   291,
     0,     0,   550,   290,     0,   292,     0,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   291,     0,     0,
   551,   290,     0,   292,     0,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   291,     0,     0,   552,   290,
     0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   302,   291,     0,     0,   564,   290,     0,   292,
     0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,   571,   290,     0,   292,     0,   293,
   294,   295,   296,   297,   298,   299,   300,   301,   302,   291,
     0,     0,   575,   290,     0,   292,   467,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   291,     0,     0,
     0,   290,     0,   292,   488,   293,   294,   295,   296,   297,
   298,   299,   300,   301,   302,   291,     0,     0,     0,   290,
     0,   292,     0,   293,   294,   295,   296,   297,   298,   299,
   300,   301,   302,   291,     0,     0,     0,   290,     0,     0,
     0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   291,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   295,   296,   297,   298,   299,   300,   301,   302
};

static short yycheck[] = {    28,
    22,    70,    36,   101,    30,    14,    90,    36,     8,     3,
    39,     3,     4,    42,    22,    44,   215,    46,     3,     3,
     4,    50,    51,    52,     3,    54,    60,   210,     6,     6,
     3,    60,    11,   180,    11,     3,     3,    45,     6,   114,
    48,     3,    24,   190,     6,     6,     7,     6,     3,     4,
    84,   234,     3,     3,   129,    84,     6,   104,    13,   206,
    68,   116,   124,    63,    43,    65,   116,   129,     3,     4,
   119,   100,   127,   120,   121,     3,    76,   127,     6,     3,
     4,    81,   124,     9,    92,    11,    78,     3,    17,    17,
   118,   118,    18,   191,    78,   123,   116,     5,     6,    31,
    92,    83,    31,    35,   124,     3,    38,   127,    92,     3,
   102,     3,     6,     3,   123,   125,   126,     6,   102,   153,
    82,     6,     3,     3,   153,   154,   118,   119,    83,    84,
   124,   123,   161,   162,   118,   119,   128,   115,   123,   168,
   224,   119,   119,    78,   173,   124,   114,   176,   177,   178,
   123,     3,   181,   222,    78,   354,   123,    92,   119,   188,
   119,   116,    78,     3,     4,   194,   116,   102,    92,   198,
    26,     3,   127,     6,   124,   322,    92,   127,   102,   248,
   114,     3,     3,   118,   119,   332,   102,     3,   123,   118,
   125,   119,     3,   117,   118,   119,   343,   344,     3,   123,
   200,   201,   118,   119,   136,   137,   138,    78,   124,   278,
   244,     3,   238,     3,     3,   244,   245,   246,   240,   219,
     3,    92,     3,   245,   246,   124,    78,    16,   160,   263,
    11,   102,    13,   233,   263,   333,   124,   124,    78,   171,
    92,   124,   124,     3,    48,    26,    78,   118,   119,     3,
   102,   124,    92,   452,    35,   124,   124,   124,    10,    78,
    92,    13,   102,   124,   124,    54,   118,   119,     3,    21,
   102,   123,     6,    92,    78,   124,   305,    29,   118,   119,
   124,   124,   214,   102,   313,   432,   118,   119,    92,   318,
   319,   320,    90,    45,   323,   124,   443,   124,   102,   118,
   119,   330,   331,    92,   124,   124,   104,   124,   337,   338,
    99,   340,   124,     6,   118,   119,   248,   249,   124,   251,
   118,   119,   120,   121,   353,   257,   258,   124,   124,   124,
     6,   353,   264,   265,   266,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   276,   277,   124,   279,   280,   281,
   282,   283,   284,   285,   286,   363,   124,   504,   290,   291,
   292,   124,   561,   124,    78,   297,   298,   299,   300,   301,
   302,     6,     3,     6,   573,     3,     3,     6,    92,    53,
   449,     6,     6,     6,   127,   125,     3,   456,   102,     5,
     6,     3,   421,     4,     3,   327,   425,     3,   104,   428,
     3,   430,   104,   432,   118,   119,   113,   436,    11,   112,
   124,   440,     6,   442,    90,   114,   118,   119,   120,   121,
   114,   126,     3,    26,     6,     3,     6,   117,   104,   127,
   464,   128,     3,   125,   110,   464,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   126,   126,   125,     6,
   125,    54,     6,     6,     3,     3,    18,   128,   124,   114,
   114,   125,    78,     3,     6,   125,   495,   125,    18,     3,
   126,   540,   124,     6,   503,    78,    92,   409,   410,   411,
   412,   413,   128,   415,     3,   519,   102,   127,   114,    92,
   519,     6,     6,     6,     6,   127,     6,     6,   128,   102,
     6,   530,   118,   119,     6,     6,   438,   110,   111,   112,
   128,     6,     6,   116,     6,   118,   119,     6,     0,   161,
   516,   124,    -1,   256,   127,   554,   458,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   467,   468,    -1,   567,    -1,
    90,   473,     3,     4,    -1,    -1,    -1,   576,    -1,    -1,
    -1,   483,    -1,   485,   104,   487,   488,    -1,    -1,    -1,
   110,    -1,   112,   113,   114,    -1,   116,   117,   118,   119,
   120,   121,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,
    -1,    -1,    90,   515,    -1,   517,    -1,    -1,    -1,    -1,
    -1,    -1,    53,    54,    -1,    -1,   104,    -1,    -1,     3,
     4,    -1,   110,    -1,   112,   113,   114,   539,   116,   117,
   118,   119,   120,   121,    -1,    -1,    -1,    78,    -1,    -1,
    -1,   553,    -1,    -1,    85,    86,    87,    88,    89,    -1,
    91,    92,    93,   565,    95,    96,    97,    98,    99,   100,
   101,   102,   103,    -1,   105,   106,   107,   108,   109,    53,
    54,    -1,    -1,   114,   115,   116,    -1,   118,   119,    -1,
    -1,    -1,    -1,   124,    -1,    -1,   127,     3,     4,    -1,
    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
    -1,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
    -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
    -1,   105,   106,   107,   108,   109,    -1,    90,    -1,    -1,
   114,   115,   116,    -1,   118,   119,    -1,    53,    54,    -1,
   124,   104,    -1,   127,    -1,    -1,    -1,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
    -1,    -1,    78,    -1,    -1,    -1,    -1,   130,    -1,    85,
    86,    87,    88,    89,    -1,    91,    92,    93,    -1,    95,
    96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
   106,   107,   108,   109,    -1,    -1,    -1,    -1,    -1,   115,
   116,    -1,   118,   119,    -1,    -1,     0,     1,   124,     3,
    -1,   127,    -1,     7,     8,     9,    10,    11,    12,    13,
    -1,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    -1,    79,    80,    81,    82,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    94,    38,    39,    40,    41,    42,    43,    -1,    -1,    46,
    47,    48,    49,    -1,    -1,    52,    53,    -1,    55,    -1,
    -1,   115,    -1,    60,    -1,    -1,    90,    64,    65,   123,
    67,    -1,    69,    -1,    71,    -1,    -1,    74,    -1,    76,
   104,    -1,    -1,    80,    81,    90,   110,    -1,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,    -1,   104,
    -1,    -1,    -1,    90,    -1,   110,   130,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   104,    -1,    -1,
    -1,   126,    90,   110,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,    -1,   104,    -1,    -1,   126,
    90,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   104,    -1,    -1,    -1,   126,    90,
   110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,    -1,   104,    -1,    -1,   126,    90,    -1,   110,
    -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,    -1,   126,    90,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
   104,    -1,    -1,   126,    90,    -1,   110,    -1,   112,   113,
   114,   115,   116,   117,   118,   119,   120,   121,   104,    -1,
    -1,    -1,   126,    90,   110,    -1,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,    -1,   104,    -1,   125,
    -1,    90,    -1,   110,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   104,    -1,    -1,   125,    90,
    -1,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   104,    -1,    -1,   125,    90,    -1,   110,
    -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,   125,    90,    -1,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   104,
    -1,    -1,   125,    90,    -1,   110,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   104,    -1,    -1,
   125,    90,    -1,   110,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   104,    -1,    -1,   125,    90,
    -1,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   104,    -1,    -1,   125,    90,    -1,   110,
    -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,   125,    90,    -1,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   104,
    -1,    -1,   125,    90,    -1,   110,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   104,    -1,    -1,
   125,    90,    -1,   110,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   104,    -1,    -1,   125,    90,
    -1,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   104,    -1,    -1,   125,    90,    -1,   110,
    -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,   125,    90,    -1,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   104,
    -1,    -1,   125,    90,    -1,   110,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   104,    -1,    -1,
   125,    90,    -1,   110,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   104,    -1,    -1,   125,    90,
    -1,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   104,    -1,    -1,   125,    90,    -1,   110,
    -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,   125,    90,    -1,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   104,
    -1,    -1,   125,    90,    -1,   110,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   104,    -1,    -1,
   125,    90,    -1,   110,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   104,    -1,    -1,   125,    90,
    -1,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   104,    -1,    -1,   125,    90,    -1,   110,
    -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,   125,    90,    -1,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   104,
    -1,    -1,   125,    90,    -1,   110,    -1,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   104,    -1,    -1,
   125,    90,    -1,   110,    -1,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   104,    -1,    -1,   125,    90,
    -1,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   104,    -1,    -1,   125,    90,    -1,   110,
    -1,   112,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,   125,    90,    -1,   110,    -1,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   104,
    -1,    -1,   125,    90,    -1,   110,   111,   112,   113,   114,
   115,   116,   117,   118,   119,   120,   121,   104,    -1,    -1,
    -1,    90,    -1,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   104,    -1,    -1,    -1,    90,
    -1,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   104,    -1,    -1,    -1,    90,    -1,    -1,
    -1,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
   121,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   114,   115,   116,   117,   118,   119,   120,   121
};
#define YYIMPURE 1

/* #line 2 "bison.simple" */

/* Skeleton output parser for bison,
   copyright (C) 1984 Bob Corbett and Richard Stallman

   Permission is granted to anyone to make or distribute verbatim copies of this program
   provided that the copyright notice and this permission notice are preserved;
   and provided that the recipient is not asked to waive or limit his right to
   redistribute copies as permitted by this permission notice;
   and provided that anyone possessing an executable copy
   is granted access to copy the source code, in machine-readable form,
   in some reasonable manner.

   Permission is granted to distribute derived works or enhanced versions of
   this program under the above conditions with the additional condition
   that the entire derivative or enhanced work
   must be covered by a permission notice identical to this one.

   Anything distributed as part of a package containing portions derived
   from this program, which cannot in current practice perform its function usefully
   in the absense of what was derived directly from this program,
   is to be considered as forming, together with the latter,
   a single work derived from this program,
   which must be entirely covered by a permission notice identical to this one
   in order for distribution of the package to be permitted.

 In other words, you are welcome to use, share and improve this program.
 You are forbidden to forbid anyone else to use, share and improve
 what you give them.   Help stamp out software-hoarding!  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#ifdef sparc
#include <alloca.h>
#endif
#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYFAIL		goto yyerrlab;

#define YYTERROR	1

#ifndef YYIMPURE
#define YYLEX		yylex()
#endif

#ifndef YYPURE
#define YYLEX		yylex(&yylval, &yylloc)
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYIMPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/

int yydebug = 0;		/*  nonzero means print parse trace	*/

#endif  /* YYIMPURE */


/*  YYMAXDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYMAXDEPTH
#define YYMAXDEPTH 200
#endif

/*  YYMAXLIMIT is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#ifndef YYMAXLIMIT
#define YYMAXLIMIT 10000
#endif


/* #line 87 "bison.simple" */
int
yyparse()
{

/*Auto Variables*/
   char buff[MACROSIZE + 1],	/* buffer for reading macros */
	       word[CHARMAX];		/* buffer for storing WORD */
/*End Auto Variables*/
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  YYLTYPE *yylsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYMAXDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYMAXDEPTH];	/*  the semantic value stack		*/
  YYLTYPE yylsa[YYMAXDEPTH];	/*  the location stack			*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */
  YYLTYPE *yyls = yylsa;

  int yymaxdepth = YYMAXDEPTH;

#ifndef YYPURE

  int yychar;
  YYSTYPE yylval;
  YYLTYPE yylloc;

  extern int yydebug;

#endif


  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

  if (yydebug)
    fprintf(stderr, "Starting parse\n");

  yystate = 0;
  yyerrstatus = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
  yylsp = yyls;

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yymaxdepth - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      YYLTYPE *yyls1 = yyls;
      short *yyss1 = yyss;

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yymaxdepth);

      yyss = yyss1; yyvs = yyvs1; yyls = yyls1;
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yymaxdepth >= YYMAXLIMIT)
	yyerror("parser stack overflow");
      yymaxdepth *= 2;
      if (yymaxdepth > YYMAXLIMIT)
	yymaxdepth = YYMAXLIMIT;
      yyss = (short *) alloca (yymaxdepth * sizeof (*yyssp));
      bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyls = (YYLTYPE *) alloca (yymaxdepth * sizeof (*yylsp));
      bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
      yyvs = (YYSTYPE *) alloca (yymaxdepth * sizeof (*yyvsp));
      bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yylsp = yyls + size - 1;
      yyvsp = yyvs + size - 1;

      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yymaxdepth);

      if (yyssp >= yyss + yymaxdepth - 1)
	YYERROR;
    }

  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
#if 0			/* Not referenced by SM parser */
yyresume:
#endif

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

      if (yydebug)
	fprintf(stderr, "Parsing next token; it is %d (%s)\n", yychar, yytname[yychar1]);
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
  *++yylsp = yylloc;

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

  if (yydebug)
    {
      if (yylen == 1)
	fprintf (stderr, "Reducing 1 value via line %d, ",
		 yyrline[yyn]);
      else
	fprintf (stderr, "Reducing %d values via line %d, ",
		 yylen, yyrline[yyn]);
    }


  switch (yyn) {

case 1:
/* #line 116 "control.y" */
{
#if defined(YYFAIL)
#  undef  YYERROR			/* work around for Bison bug */
#  define YYERROR YYFAIL		/* must be here, not in preamble */
#endif
	    start_line();
	 ;
    break;}
case 3:
/* #line 127 "control.y" */
{
	    fflush(stdout); fflush(stderr);
	    if(buff_is_empty()) {	/* no characters on input buffer */
	       if(graph_mode) {
		  IDLE();		/* out of graphics mode */
		  graph_mode = 0;
	       }
	       return(1);
	    }
	    start_line();		/* start a new line in tokens.c */
	 ;
    break;}
case 4:
/* #line 139 "control.y" */
{
	    char cmd[200];		/* command to execute */
	    char *shell;		/* the shell to use */

	    reset_term();
	    (void)mgets(cmd,MACROSIZE);	/* read rest of line */
	    if(*(shell = print_var("SHELL")) != '\0' &&
						strcmp(shell,"/bin/sh") != 0) {
	       sprintf(buff,"%s -c \"%s\"",shell,cmd);
	       set_exit_status(system(buff));
	    } else {
	       set_exit_status(system(cmd));
	    }
	    set_term();
	 ;
    break;}
case 5:
/* #line 155 "control.y" */
{
	    extern int abort_plot;

	    abort_plot = 1;
	    if(graph_mode) { IDLE(); graph_mode = 0; }
	    CLOSE(); stg_close();
	    devnum = NODEVICE;
	    SETUP("");
	    if(in_graphics) { ENABLE(); graph_mode = 1; }
	    set_dev();
	    abort_plot = 0;
	 ;
    break;}
case 6:
/* #line 168 "control.y" */
{
	    set_angle(yyvsp[0].vector.vec.f,yyvsp[0].vector.dimen);
	    vec_free(&yyvsp[0].vector);
	 ;
    break;}
case 7:
/* #line 173 "control.y" */
{
	    (void)mgets(buff,CHARMAX);	/* read rest of line */
	    help_apropos(&buff[1]);
	    macro_apropos(&buff[1]);
	 ;
    break;}
case 8:
/* #line 179 "control.y" */
{ set_aspect( yyvsp[0].floatval ); ;
    break;}
case 9:
/* #line 181 "control.y" */
{
	    if(yyvsp[0].charval[0] == '~') {
	       if(getenv("HOME") == NULL) {
		  msg("can't expand ~  : HOME is not defined\n");
		  (void)strcpy(buff,yyvsp[0].charval);
	       }
	       (void)sprintf(buff,"%s%s",getenv("HOME"),&yyvsp[0].charval[1]);
	    } else {
	       (void)strcpy(buff,yyvsp[0].charval);
	    }
#if 0 && defined(VMS)			/* let's see if this works */
	    msg("Chdir is not currently provided, due to a VMS bug\n");
	    break;
#endif
#if defined(__MSDOS__)
	    if(buff[1] == ':') {
	       setdisk(isupper(buff[0]) ? tolower(buff[0]) : buff[0]);
	       if(buff[2] == '\0') break;
	    }
#endif
	    if(chdir(buff) != 0) {
	       perror("Error in CHDIR ");
	    }
	 ;
    break;}
case 10:
/* #line 206 "control.y" */
{
	    FILE *fil;

	    if((fil = fopen(yyvsp[0].charval,"r")) == NULL) {
	       msg_1s("Can't open %s\n",yyvsp[0].charval);
	    } else {
	       (void)fclose(fil);
	    }
	    (void)strncpy(data_file,yyvsp[0].charval,CHARMAX); /* the file to read data */
	    line_1 = line_2 = 0;	/* no lines specified */
	    set_data_file(yyvsp[0].charval);
	 ;
    break;}
case 11:
/* #line 219 "control.y" */
{
	    if(yyvsp[0].strval.start == NULL) break;
	    *(yyvsp[0].strval.end) = '\0';		/* remove '\n' */
	    if(yyvsp[-1].charval[0] != '\0') setvar(yyvsp[-1].charval,yyvsp[0].strval.start);
            free(yyvsp[0].strval.start);
	 ;
    break;}
case 12:
/* #line 226 "control.y" */
{
	    if(yyvsp[-1].charval[0] != '\0') setvar(yyvsp[-1].charval,read_image_variable(yyvsp[-1].charval));
	 ;
    break;}
case 13:
/* #line 230 "control.y" */
{
	    char *temp;

	    if(yyvsp[-2].charval[0] == '\0' || (temp = read_variable(data_file,yyvsp[0].intval,0)) 
                                				   == NULL) {
	       break;
	    }
	    setvar(yyvsp[-2].charval,temp);
	 ;
    break;}
case 14:
/* #line 240 "control.y" */
{
	    char *temp;

	    if(yyvsp[-3].charval[0] == '\0' || (temp = read_variable(data_file,yyvsp[-1].intval,yyvsp[0].intval)) 
				                                 == NULL) {
	       break;
	    }
	    setvar(yyvsp[-3].charval,temp);
	 ;
    break;}
case 15:
/* #line 250 "control.y" */
{ if(yyvsp[-1].charval[0] != '\0') setvar(yyvsp[-1].charval,yyvsp[0].charval); ;
    break;}
case 16:
/* #line 252 "control.y" */
{
	    char *temp;

	    if(yyvsp[-1].charval[0] != '\0') {
	       if((temp = get_val(yyvsp[-1].charval)) != NULL) {
		  setvar(yyvsp[-1].charval,temp);
	       } else {
		  if(sm_verbose > 1)
		     msg_1s("%s is not defined in the environment file\n",yyvsp[-1].charval);
	       }
	    }
	 ;
    break;}
case 17:
/* #line 265 "control.y" */
{
	    char *oldval;		/* old value of variable */

	    if(yyvsp[-2].charval[0] == '\0' || yyvsp[0].strval.start == NULL) {
	       if(yyvsp[0].strval.start != NULL) free(yyvsp[0].strval.start);
	       break;
	    }
	    *(yyvsp[0].strval.end) = '\0';		/* remove '\n' */
	    
	    if(graph_mode) { IDLE(); graph_mode = 0; }
	    
	    oldval = print_var(yyvsp[-2].charval);
	    for(;;) {
	       if(yyvsp[0].strval.start[0] == '\0') {
		  printf("%s ? [%s] ",yyvsp[-2].charval,oldval);
	       } else {			/* use prompt specified */
		  printf("%s [%s] ",yyvsp[0].strval.start,oldval);
	       }
	       fflush(stdout);
	       free(yyvsp[0].strval.start);
	       (void)fgets(word,CHARMAX,stdin); word[strlen(word) - 1] = '\0';
	       if(logfil != NULL) fprintf(logfil,"%s\n",word);
	       if(word[0] != '\0') {	/* new value */
		  setvar(yyvsp[-2].charval,word);
		  break;
	       } else if(oldval[0] == '\0') {
		  printf("There is no default value for %s\n",yyvsp[-2].charval);
		  fflush(stdout);
	       } else {			/* keep old value */
		  break;
	       }
	    }
	    if(in_graphics) { ENABLE(); graph_mode = 1; }
	 ;
    break;}
case 18:
/* #line 300 "control.y" */
{
	    int i;
	    
	    if(yyvsp[-1].charval[0] != '\0') {
	       if((i = index_variable(yyvsp[-1].charval)) < 0) {
		  msg_1s("%s is not a valid internal variable\n",yyvsp[-1].charval);
		  break;
	       }
	       setvar(yyvsp[-1].charval,get_variable(i));
	    }
	 ;
    break;}
case 19:
/* #line 312 "control.y" */
{
	    if(yyvsp[-3].charval[0] != '\0') {
	       if(yyvsp[-1].vector.dimen <= 0) {
		  msg_1s("vector %s has no value\n",yyvsp[-1].vector.name);
		  break;
	       }
	       if(yyvsp[-1].vector.type == VEC_STRING) {
		  setvar(yyvsp[-3].charval,yyvsp[-1].vector.vec.s.s[0]);
	       } else {
		  (void)sprintf(buff,"%g",yyvsp[-1].vector.vec.f[0]);
		  setvar(yyvsp[-3].charval,buff);
	       }
	    }
	 ;
    break;}
case 20:
/* #line 327 "control.y" */
{ if(yyvsp[-1].charval[0] != '\0') setvar(yyvsp[-1].charval,"delete"); ;
    break;}
case 21:
/* #line 329 "control.y" */
{
	    delete_last_history(1);	/* forget this command */
	    delete_last_history(1);	/* and the last one too */
	 ;
    break;}
case 22:
/* #line 334 "control.y" */
{ delete_history(yyvsp[0].intval,yyvsp[0].intval,1); ;
    break;}
case 23:
/* #line 336 "control.y" */
{ delete_history(yyvsp[-1].intval,yyvsp[0].intval,1); ;
    break;}
case 24:
/* #line 338 "control.y" */
{ delete_last_history(0); ;
    break;}
case 25:
/* #line 340 "control.y" */
{ delete_last_history(1); ;
    break;}
case 26:
/* #line 342 "control.y" */
{ delete_history(yyvsp[0].intval,yyvsp[0].intval,0); ;
    break;}
case 27:
/* #line 344 "control.y" */
{ delete_history(yyvsp[-1].intval,yyvsp[0].intval,0); ;
    break;}
case 28:
/* #line 346 "control.y" */
{ (void)free_vector(yyvsp[0].charval); ;
    break;}
case 29:
/* #line 348 "control.y" */
{
	      if(graph_mode) IDLE();
	      CLOSE(); stg_close();
	      devnum = NODEVICE;

	      (void)mgets(word,CHARMAX); /* read rest of line */
	      if(yyvsp[0].intval >= 0 && yyvsp[0].intval < ndev) {
		 if((*devices[yyvsp[0].intval].dev_setup)(word) >= 0) {
		    devnum = yyvsp[0].intval;
		 } else {
		    msg_1s("No such device %s\n",word);
		 }
	      } else {
	         msg_1d("No such device %d\n",yyvsp[0].intval);
	      }
	      ENABLE(); graph_mode = 1;
	      set_dev();
	   ;
    break;}
case 30:
/* #line 367 "control.y" */
{
	      if(strcmp(yyvsp[0].charval,"close") == 0 || strcmp(yyvsp[0].charval,"CLOSE") == 0) {
		 close_metafile();
	      } else {
		 open_metafile(yyvsp[0].charval);
	      }
	   ;
    break;}
case 31:
/* #line 375 "control.y" */
{
    	      int dn;

	      if(graph_mode) IDLE();
	      CLOSE(); stg_close();
	      devnum = NODEVICE;

	      (void)sprintf(buff,"%s",yyvsp[0].charval);
	      (void)mgets(word,CHARMAX); /* read rest of line */
	      (void)strncat(buff,word,MACROSIZE);

	      if((dn = stg_setup(buff)) < 0) {
		 devnum = NODEVICE;
		 msg_1s("No such device %s\n",buff);
	      } else {
		 devnum = dn;
	      }

	      ENABLE(); graph_mode = 1;
	      set_dev();
	   ;
    break;}
case 32:
/* #line 397 "control.y" */
{
	    if(yyvsp[-8].charval[0] == '\0' || yyvsp[-1].strval.start == NULL) {
	       if(yyvsp[-1].strval.start != NULL) free(yyvsp[-1].strval.start);
	       break;
	    }

	    push_dstack(yyvsp[-8].charval,yyvsp[-6].floatval,yyvsp[-4].floatval,yyvsp[-3].floatval);	/* set up DO variables */
	    if(next_do() == 0) {	/* set intial value of DO variable */
	       push(yyvsp[-1].strval.start,S_DO);	/* push body of DO loop */
	    }
         ;
    break;}
case 33:
/* #line 408 "control.y" */
{ (void)mscanstr(yyval.charval,CHARMAX); ;
    break;}
case 34:
/* #line 409 "control.y" */
{ define_map(yyvsp[-1].charval,yyvsp[0].charval); ;
    break;}
case 35:
/* #line 411 "control.y" */
{
	    lexflush();			/* flush lex buffer */
            yyerrok;
            yyclearin;			/* reset the parser */
	    start_line();		/* start a new line in tokens.c */
	    if(graph_mode) {
	       IDLE();
	       graph_mode = 0;
	    }
	    if(recurse_lvl) {
	       if(recurse_lvl > 1) {	/* keep on popping */
		  push("SNARK ",S_TEMP);
	       }
	       recurse_lvl--;
	       return(1);
	    }
	    if(buff_is_empty()) {	/* no characters on input buffer */
	       return(1);
	    }
         ;
    break;}
case 36:
/* #line 432 "control.y" */
{
	    set_expand(yyvsp[0].vector.vec.f,yyvsp[0].vector.dimen);
	    vec_free(&yyvsp[0].vector);
	 ;
    break;}
case 37:
/* #line 437 "control.y" */
{
	    VECTOR *temp_r,*temp_i;
	    
	    if(yyvsp[-4].floatval != 1 && yyvsp[-4].floatval != -1) {
	       msg_1f("You must specify 1 or -1 for an FFT, not %g\n",yyvsp[-4].floatval);
	       vec_free(&yyvsp[-3].vector);
	       vec_free(&yyvsp[-2].vector);
	       break;
	    }
	    if(yyvsp[-3].vector.dimen != yyvsp[-2].vector.dimen) {
	       msg_2s("Vectors %s and %s have different dimensions\n",
		      yyvsp[-3].vector.name,yyvsp[-2].vector.name);
	       vec_free(&yyvsp[-3].vector);
	       vec_free(&yyvsp[-2].vector);
	       break;
	    }
	    if((temp_r = make_vector(yyvsp[-1].charval,yyvsp[-3].vector.dimen,VEC_FLOAT)) == NULL) {
	       vec_free(&yyvsp[-3].vector);
	       vec_free(&yyvsp[-2].vector);
	       break;
	    }
	    if((temp_i = make_vector(yyvsp[0].charval,yyvsp[-3].vector.dimen,VEC_FLOAT)) == NULL) {
	       vec_free(&yyvsp[-3].vector);
	       vec_free(&yyvsp[-2].vector);
	       free_vector(yyvsp[-1].charval);
	       break;
	    }
	    (void)fft(yyvsp[-3].vector.vec.f,yyvsp[-2].vector.vec.f,temp_r->vec.f,temp_i->vec.f,yyvsp[-3].vector.dimen,
								      (int)yyvsp[-4].floatval);
	    vec_free(&yyvsp[-3].vector);
	    vec_free(&yyvsp[-2].vector);
	 ;
    break;}
case 38:
/* #line 470 "control.y" */
{
	    if(yyvsp[-4].charval[0] == '\0' || yyvsp[-3].t_list == NULL || yyvsp[-1].strval.start == NULL) {
	       freelist(yyvsp[-3].t_list);
	       if(yyvsp[-1].strval.start != NULL) free(yyvsp[-1].strval.start);
	       break;
	    }
	    if(yyvsp[-3].t_list->nitem <= 0) {	/* Null list */
	       msg_1s("FOREACH %s variable list is empty\n",yyvsp[-4].charval);
	       freelist(yyvsp[-3].t_list);
	       free(yyvsp[-1].strval.start);
	       break;
	    }
	    push_fstack(yyvsp[-4].charval,yyvsp[-3].t_list);
	    (void)next_foreach();
	    push(yyvsp[-1].strval.start,S_FOREACH);	/* $3 and $5 will be freed later */
         ;
    break;}
case 39:
/* #line 487 "control.y" */
{ sm_format( yyvsp[-1].charval, yyvsp[0].charval ); ;
    break;}
case 40:
/* #line 489 "control.y" */
{
	    sm_format("1","1");
	    (void)unput('\n');
	 ;
    break;}
case 41:
/* #line 493 "control.y" */
{
	   in_graphics = 1;
	   if(!graph_mode) { ENABLE(); graph_mode = 1; }
        ;
    break;}
case 42:
/* #line 498 "control.y" */
{ in_graphics = 0; GFLUSH(); ;
    break;}
case 43:
/* #line 500 "control.y" */
{
	    char *var;
	    int i,j;

	    if(graph_mode) { IDLE(); graph_mode = 0; }
            (void)mgets(word,CHARMAX);	/* will have leading ' ' */
	    for(j = strlen(word) - 1;j >= 0 && isspace(word[j]);j--) {
	       word[j] = '\0';
	    }
	    for(i = 0;i < j && isspace(word[i]);i++) ;
	    if(word[i] == '\0') {
	       (void)strcpy(word,"help");
	       i = 0;
	    }
            if((j = help(&word[i])) < 0) {	/* in help directory? */
	       break;
	    }
            j += (what_is(&word[i]) == 0);	/* maybe it's a macro */
	    var = print_var(&word[i]);
	    j += (var[0] != '\0');		/* or a variable? */
	    if(var[0] != '\0') {
	       (void)printf("Variable : %s\n",var);
	    }
	    j += (help_vector(&word[i]) == 0);	/* maybe a vector? */
	    if(j == 0) {			/* nothing we know about */
	       (void)fprintf(stderr,"I'm sorry %s, %s\n",user_name,
					  "but I can't help you with that.");
            }
	    fflush(stdout);
         ;
    break;}
case 44:
/* #line 531 "control.y" */
{ history_list(1); ;
    break;}
case 45:
/* #line 533 "control.y" */
{ history_list(-1); ;
    break;}
case 46:
/* #line 535 "control.y" */
{
	    (void)unput('\n');
	    if(yyvsp[-2].strval.start == NULL) break;
	    if(yyvsp[-5].floatval) {
	       push(yyvsp[-2].strval.start,S_TEMP);
	    } else {
	       free(yyvsp[-2].strval.start);
	    }
	 ;
    break;}
case 47:
/* #line 545 "control.y" */
{
	    char *if_body;
	    
	    if(yyvsp[-5].strval.start == NULL) {
	       if(yyvsp[-1].strval.start != NULL) free(yyvsp[-1].strval.start);
	       break;
	    }
	    if(yyvsp[-1].strval.start == NULL) {
	       free(yyvsp[-5].strval.start);
	       break;
	    }
	    
	    if(yyvsp[-8].floatval) {
	       free(yyvsp[-1].strval.start);
	       if_body = yyvsp[-5].strval.start;
	    } else {
	       free(yyvsp[-5].strval.start);
	       if_body = yyvsp[-1].strval.start;
	    }

	    push(if_body,S_TEMP);
	 ;
    break;}
case 48:
/* #line 568 "control.y" */
{
	   in_graphics = 1;
	   if(!graph_mode) { ENABLE(); graph_mode = 1; }
	   sm_cursor(1);
	   in_graphics = 0; GFLUSH();
	;
    break;}
case 49:
/* #line 575 "control.y" */
{ (void)sm_delimage(); ;
    break;}
case 50:
/* #line 577 "control.y" */
{
	    (void)read_image(yyvsp[0].charval,0.0,0.0,0.0,0.0);
	    (void)unput('\n');
	 ;
    break;}
case 51:
/* #line 582 "control.y" */
{ (void)read_image(yyvsp[-4].charval,yyvsp[-3].floatval,yyvsp[-2].floatval,yyvsp[-1].floatval,yyvsp[0].floatval); ;
    break;}
case 52:
/* #line 584 "control.y" */
{ create_image(yyvsp[-3].intval,yyvsp[-1].intval,0.0,(float)yyvsp[-3].intval - 1,0.0,(float)yyvsp[-1].intval - 1); ;
    break;}
case 53:
/* #line 586 "control.y" */
{ create_image(yyvsp[-7].intval,yyvsp[-5].intval,yyvsp[-3].floatval,yyvsp[-2].floatval,yyvsp[-1].floatval,yyvsp[0].floatval); ;
    break;}
case 54:
/* #line 588 "control.y" */
{
	    float *vals;
	    int i;

   	    if((vals = (float *)malloc((unsigned)(yyvsp[0].vector.dimen)*sizeof(float)))
								 == NULL) {
  	       msg("Can't allocate space for levels\n");
	       vec_free(&yyvsp[0].vector);
  	       break;
     	    }
     	    for(i = 0;i < yyvsp[0].vector.dimen;i++) {
     	       vals[i] = yyvsp[0].vector.vec.f[i];
    	    }
	    sm_levels(vals,(int)yyvsp[0].vector.dimen);
	    vec_free(&yyvsp[0].vector);
         ;
    break;}
case 55:
/* #line 605 "control.y" */
{
	    if(fabs(x_range) > 1e-20) {
	       yyvsp[-1].pairval.a = yyvsp[-1].pairval.med - x_range/2;
	       yyvsp[-1].pairval.b = yyvsp[-1].pairval.med + x_range/2;
	    }
	    if(fabs(y_range) > 1e-20) {
	       yyvsp[0].pairval.a = yyvsp[0].pairval.med - y_range/2;
	       yyvsp[0].pairval.b = yyvsp[0].pairval.med + y_range/2;
	    }
	    (void)sm_limits( yyvsp[-1].pairval.a, yyvsp[-1].pairval.b, yyvsp[0].pairval.a, yyvsp[0].pairval.b );
	 ;
    break;}
case 56:
/* #line 617 "control.y" */
{ key_macro(); ;
    break;}
case 57:
/* #line 619 "control.y" */
{
	    line_1 = yyvsp[-1].intval;
	    line_2 = yyvsp[0].intval;
	    sprintf(buff,"%d",line_1); setvar("_l1",buff);
	    sprintf(buff,"%d",line_2); setvar("_l2",buff);
	 ;
    break;}
case 58:
/* #line 626 "control.y" */
{
            (void)varlist(0,255);
            (void)unput('\n');
         ;
    break;}
case 59:
/* #line 631 "control.y" */
{ (void)varlist(yyvsp[-1].charval[0],yyvsp[0].charval[0]); ;
    break;}
case 60:
/* #line 633 "control.y" */
{ stg_list(); ;
    break;}
case 61:
/* #line 635 "control.y" */
{ list_edit(); ;
    break;}
case 62:
/* #line 637 "control.y" */
{
            (void)macrolist('\0','\177');
            (void)unput('\n');
         ;
    break;}
case 63:
/* #line 642 "control.y" */
{ (void)macrolist(yyvsp[-1].charval[0],yyvsp[0].charval[0]); ;
    break;}
case 64:
/* #line 644 "control.y" */
{ list_vectors(); ;
    break;}
case 65:
/* #line 646 "control.y" */
{ (void)sm_location( yyvsp[-3].intval, yyvsp[-2].intval, yyvsp[-1].intval, yyvsp[0].intval); ;
    break;}
case 66:
/* #line 648 "control.y" */
{
	    if(yyvsp[0].floatval < 0) {
	       msg("LWEIGHT cannot be negative; setting to zero\n");
	       yyvsp[0].floatval = 0;
	    }
	    sm_lweight(yyvsp[0].floatval);
	 ;
    break;}
case 67:
/* #line 656 "control.y" */
{
	    if(yyvsp[0].strval.start == NULL) break;
            *(yyvsp[0].strval.end) = '\0';		/* remove '\n' */
            (void)define(yyvsp[-2].charval,yyvsp[0].strval.start,yyvsp[-1].intval);

            free(yyvsp[0].strval.start);
         ;
    break;}
case 68:
/* #line 664 "control.y" */
{ (void)define(yyvsp[-1].charval,"delete",0); ;
    break;}
case 69:
/* #line 666 "control.y" */
{ (void)define_history_macro(yyvsp[-2].charval,yyvsp[-1].intval,yyvsp[0].intval);;
    break;}
case 70:
/* #line 668 "control.y" */
{ (void)macro_edit(yyvsp[0].charval); ;
    break;}
case 71:
/* #line 670 "control.y" */
{
	    FILE *fil;

	    if((fil = fopen(yyvsp[0].charval,"r")) == NULL) {
	       msg_1s("can't open %s\n",yyvsp[0].charval);
	       break;
	    }
	    (void)read_macros(fil);
	    (void)fclose(fil);
	 ;
    break;}
case 72:
/* #line 681 "control.y" */
{ (void)undefine_macros(yyvsp[0].charval); ;
    break;}
case 73:
/* #line 683 "control.y" */
{
	    FILE *fil;

            (void)unput('\n');
	    if(would_clobber(yyvsp[-1].charval)) {
	       break;
	    }
	    if((fil = fopen(yyvsp[-1].charval,"w")) == NULL) {
	       msg_1s("can't open %s\n",yyvsp[-1].charval);
	       break;
	    }
            (void)write_macros(fil,1);	/* write all macros */
	    (void)fclose(fil);
         ;
    break;}
case 74:
/* #line 698 "control.y" */
{ (void)write_one_macro(yyvsp[-2].charval,yyvsp[0].charval,(yyvsp[-1].intval == '+')); ;
    break;}
case 75:
/* #line 700 "control.y" */
{ playback_metafile(yyvsp[0].charval); ;
    break;}
case 76:
/* #line 702 "control.y" */
{
	    float min,max;

	    sm_minmax(&min,&max);
	    (void)sprintf(buff,"%g",min);
	    setvar(yyvsp[-1].charval,buff);
	    (void)sprintf(buff,"%g",max);
	    setvar(yyvsp[0].charval,buff);
	 ;
    break;}
case 77:
/* #line 712 "control.y" */
{ sm_notation( yyvsp[-3].floatval, yyvsp[-2].floatval, yyvsp[-1].floatval, yyvsp[0].floatval ); ;
    break;}
case 78:
/* #line 714 "control.y" */
{ overload(yyvsp[-1].charval,yyvsp[0].intval); ;
    break;}
case 79:
/* #line 716 "control.y" */
{
	    int append = (yyvsp[-3].intval == '+');  
	    int dimen = 0,i,nvec;
	    VECTOR *temp[10];

	    if(!append && would_clobber(yyvsp[-2].charval)) {
	       break;
	    }
	    if(graph_mode) { graph_mode = 0; IDLE(); }

	    if((nvec = yyvsp[0].t_list->nitem) > 10) {
	       msg("Sorry, I can only print 10 vectors\n");
	       nvec = 10;
	    }

	    for(i = 0;i < nvec && !sm_interrupt;i++) {	/* get vectors */
	       if((temp[i] = get_vector_ptr(yyvsp[0].t_list->i_list[i])) == NULL) {
		  break;
	       }
	       if(i == 0) {
		  dimen = temp[0]->dimen;
	       } else if(temp[i]->dimen != dimen) {
		  if(sm_verbose > 1)
		     msg("Vectors are different sizes\n");
		  if(dimen < temp[i]->dimen) {
		     dimen = temp[i]->dimen;
		  }
	       }
	    }
	    if(i < nvec) {
               freelist(yyvsp[0].t_list);
	       break;
	    }

	    print_vec(yyvsp[-2].charval,append ? "a" : "w",yyvsp[-1].charval,nvec,temp,dimen);
	    
            freelist(yyvsp[0].t_list);
	 ;
    break;}
case 80:
/* #line 755 "control.y" */
{
	    int i;

	    (void)mgets(buff,100);
	    for(plength = 0,i = 0;buff[i + 1] != '\0';i++) {
	       prompt[i] = buff[i + 1];
	       if(prompt[i] == '*') prompt[i] = '\007'; /* replace * with ^G */
	       if(isprint(prompt[i])) plength++;
	    }
	    plength++;			/* allow for ' ' */
	    prompt[i] = '\0';
         ;
    break;}
case 81:
/* #line 768 "control.y" */
{
	    float pstyle[1];

	    pstyle[0] = 10*yyvsp[-1].intval + yyvsp[0].intval;
	    sm_ptype( pstyle, 1 );
	 ;
    break;}
case 82:
/* #line 775 "control.y" */
{
	    VECTOR *tptr;

	    if((tptr = get_vector_ptr(yyvsp[0].charval)) == NULL) {
	       break;
	    }
	    switch (tptr->type) {
	     case VEC_FLOAT:
	       sm_ptype(tptr->vec.f,tptr->dimen);
	       break;
	     case VEC_STRING:
	       ptype_str(tptr->name,tptr->vec.s.s_s,tptr->dimen);
	       break;
	     default:
	       msg_1s("%s is an ",yyvsp[0].charval);
	       msg_1d("unknown type of vector: %d\n",tptr->type);
	       break;
	    }
	 ;
    break;}
case 83:
/* #line 795 "control.y" */
{
	    if(yyvsp[-1].vector.type != VEC_FLOAT) {
	       msg_1s("%s is not an arithmetic expression\n",yyvsp[-1].vector.name);
	       break;
	    }
	    sm_ptype( yyvsp[-1].vector.vec.f, yyvsp[-1].vector.dimen );
	    vec_free(&yyvsp[-1].vector);
	 ;
    break;}
case 84:
/* #line 804 "control.y" */
{
	    if(yyvsp[0].t_list == NULL) break;
	    if(yyvsp[0].t_list->nitem <= 0) {	/* Null symbol list */
	       msg("Symbol definition list is empty\n");
	       freelist(yyvsp[0].t_list);
	       break;
	    }	       

	    setsym(yyvsp[0].t_list);
	    freelist(yyvsp[0].t_list);
	 ;
    break;}
case 85:
/* #line 816 "control.y" */
{
	    if(graph_mode) IDLE();
	    CLOSE(); stg_close();
	    return(-1);
	 ;
    break;}
case 86:
/* #line 822 "control.y" */
{
	    x_range = yyvsp[-1].floatval;
	    y_range = yyvsp[0].floatval;
	 ;
    break;}
case 87:
/* #line 827 "control.y" */
{ (void)read_map(yyvsp[0].charval); ;
    break;}
case 88:
/* #line 829 "control.y" */
{ read_old(yyvsp[-1].charval,yyvsp[0].charval); ;
    break;}
case 89:
/* #line 831 "control.y" */
{
	    int col;
	    VECTOR temp;

	    col = atoi(yyvsp[0].charval);
	    temp.type = parse_qualifier(yyvsp[0].charval);
	    temp.name = yyvsp[-1].charval;
	    if(read_row(data_file,col,&temp) == 0) {
	       copy_vector(temp.name,temp);
	    }
	 ;
    break;}
case 90:
/* #line 843 "control.y" */
{
	    int col;
	    VECTOR *tptr,temp;

	    tptr = &temp;
	    col = atoi(yyvsp[0].charval);
	    temp.name = yyvsp[-1].charval;
	    temp.type = parse_qualifier(yyvsp[0].charval);
	    if(read_column(data_file,&col,&tptr,1,line_1,line_2,"") == 1) {
	       copy_vector(temp.name,temp);
	    }
	 ;
    break;}
case 91:
/* #line 856 "control.y" */
{
	    int cols[20],
	        extra,			/* extra i_list items processed */
	        i,j,k,
	        ncol,nvec;
	    int n1,n2;			/* range of columns for a vector */
	    VECTOR temp[20],*tptr[20];

	    if(yyvsp[0].t_list == NULL) break;
	    ncol = yyvsp[0].t_list->nitem;
	    for(i = j = 0;i < ncol;i += 2 + extra) {
	       if(i + 1 == ncol) {
		  msg_1s("Ignoring extra field at end of READ list: %s\n",
			 yyvsp[0].t_list->i_list[i]);
		  break;
	       }
	       extra = 0;
	       if(strchr(yyvsp[0].t_list->i_list[i + 1],'-') != NULL) {
		  char *ptr = yyvsp[0].t_list->i_list[i + 1];
		  if(*ptr == '-') {	/* a single -ve number */
		     n1 = n2 = atoi(ptr);
		  } else {
		     n1 = atoi(ptr); while(*ptr != '-') ptr++;
		     ptr++;
		     n2 = atoi(ptr);
		  }
	       } else if(i + 2 < ncol && yyvsp[0].t_list->i_list[i + 2][0] == '-') {
		  n1 = atoi(yyvsp[0].t_list->i_list[i + 1]);
		  n2 = atoi(yyvsp[0].t_list->i_list[i + 2] + 1);
		  extra = 1;		/* we parsed an extra field */
	       } else {
		  n1 = n2 = atoi(yyvsp[0].t_list->i_list[i + 1]);
	       }
	       
	       for(k = n1;k <= n2;k++) {
		  if(j >= 20) {
		     msg("Sorry, you can only read 20 columns at a time\n");
		     break;
		  }
		  tptr[j] = &temp[j];
		  tptr[j]->type = parse_qualifier(yyvsp[0].t_list->i_list[i + 1]);
		  if(n1 == n2) {
		     sprintf(tptr[j]->descrip,"\001%s",yyvsp[0].t_list->i_list[i]);
		  } else {
		     if(tptr[j]->type != VEC_FLOAT) {
			msg_1s("Multi-column vectors must be numeric (%s)\n",
			       yyvsp[0].t_list->i_list[i]);
			continue;
		     }
		     if(k == n1) {
			sprintf(tptr[j]->descrip,"\001+%s",yyvsp[0].t_list->i_list[i]);
		     } else {
			sprintf(tptr[j]->descrip,"\001|%s%d",
				yyvsp[0].t_list->i_list[i],k - n1);
		     }
		  }
		  tptr[j]->name = tptr[j]->descrip + 1;
		  cols[j++] = k;
	       }
	    }
	    freelist(yyvsp[0].t_list);

	    nvec = read_column(data_file,cols,tptr,j,line_1,line_2,"");

	    for(i = 0;i < nvec;i++) {
	       if(*temp[i].name != '+') {
		  copy_vector(temp[i].name,temp[i]);
	       } else {
		  int nmerge;
		  VECTOR merged;

		  for(j = i + 1;j < nvec && *temp[j].name == '|';j++) continue;
		  nmerge = j - i;
		  merged.type = temp[i].type;
		  
		  if(vec_malloc(&merged,nmerge*temp[i].dimen) != 0) {
		     msg_1s("Can't get space for %s\n",temp[i].name + 1);
		  } else {
		     for(j = 0;j < nmerge;j++) {
			for(k = 0;k < temp[i].dimen;k++) {
			   merged.vec.f[j + nmerge*k] = temp[i + j].vec.f[k];
			}
		     }
		     copy_vector(temp[i].name + 1,merged);
		  }
		  
		  vec_free(&temp[i++]);
		  while(i < nvec && *temp[i].name == '|') {
		     vec_free(&temp[i]);
		  }
	       }
	    }
	 ;
    break;}
case 92:
/* #line 950 "control.y" */
{
	    int i,cols[1],nvec;
	    VECTOR **vecs, *s_vecs;

	    if(yyvsp[0].t_list == NULL) break;

	    if((vecs = (VECTOR **)malloc(yyvsp[0].t_list->nitem*sizeof(VECTOR *)))== NULL ||
	       (s_vecs = (VECTOR *)malloc(yyvsp[0].t_list->nitem*sizeof(VECTOR))) == NULL) {
	       msg("Can't allocate storage for vecs in READ string { ... }\n");
	       if(vecs != NULL) free((char *)vecs);
	       freelist(yyvsp[0].t_list);
	       break;
	    }
	    nvec = 0;
	    for(i = 0;i < yyvsp[0].t_list->nitem;i++) {
	       if(isdigit(yyvsp[0].t_list->i_list[i][0])) {
		  msg_1s("%s isn't a valid name for a vector\n",yyvsp[0].t_list->i_list[i]);
		  continue;
	       }
	       vecs[nvec] = s_vecs + nvec;
	       vecs[nvec++]->name = yyvsp[0].t_list->i_list[i]; /* type will come from fmt*/
	    }
	    cols[0] = 1;		/* don't just print data */
	    nvec = read_column(data_file,cols,vecs,nvec,line_1,line_2,yyvsp[-1].charval);

	    for(i = 0;i < nvec;i++) {
	       copy_vector(vecs[i]->name,*vecs[i]);
	    }
	    free((char *)vecs); free((char *)s_vecs);
            freelist(yyvsp[0].t_list);
	 ;
    break;}
case 93:
/* #line 982 "control.y" */
{ restore(yyvsp[0].charval); ;
    break;}
case 94:
/* #line 984 "control.y" */
{ mac_return(); ;
    break;}
case 95:
/* #line 986 "control.y" */
{ save(yyvsp[0].charval,0); ;
    break;}
case 96:
/* #line 988 "control.y" */
{
	    int dimension,i;
	    VECTOR *temp;

	    dimension = (int)(atoi(yyvsp[0].charval) + 0.5);
	    i = parse_qualifier(yyvsp[0].charval);
	    if((temp = make_vector(yyvsp[-3].charval,dimension,i)) != NULL) {
	       if(temp->type == VEC_FLOAT) {
		  for(i = 0;i < dimension;i++) {
		     temp->vec.f[i] = 0;
		  }
	       } else {
		  for(i = 0;i < dimension;i++) {
		     temp->vec.s.s[i][0] = '\0';
		  }
	       }
	    }
	 ;
    break;}
case 97:
/* #line 1007 "control.y" */
{
	    if(*mgets(word,CHARMAX) != '\0') {
	       set_help_vector(yyvsp[0].charval,word);
	    }
	 ;
    break;}
case 98:
/* #line 1013 "control.y" */
{ vec_set_image(&yyvsp[-5].vector,&yyvsp[-3].vector,&yyvsp[0].vector); ;
    break;}
case 99:
/* #line 1015 "control.y" */
{ set_random((long)yyvsp[0].floatval); ;
    break;}
case 100:
/* #line 1017 "control.y" */
{ (void)copy_vector(yyvsp[-2].charval,yyvsp[0].vector); ;
    break;}
case 101:
/* #line 1019 "control.y" */
{
	    int i,j;

	    if(yyvsp[-1].vector.dimen != yyvsp[-4].vector.dimen) {
	       msg("Logical vector is a different length\n");
	    }

	    for(i = 0,j = 0;i < yyvsp[-4].vector.dimen;i++) {
	       if(i > yyvsp[-1].vector.dimen || yyvsp[-1].vector.vec.f[i]) { /* copy acceptable elements */
		  if(yyvsp[-4].vector.type == VEC_FLOAT) {
		     yyvsp[-4].vector.vec.f[j] = yyvsp[-4].vector.vec.f[i];
		  } else if(yyvsp[-4].vector.type == VEC_STRING) {
		     (void)strncpy(yyvsp[-4].vector.vec.s.s[j],yyvsp[-4].vector.vec.s.s[i],VEC_STR_SIZE);
		  }
		  j++;
	       }
	    }
	    vec_free(&yyvsp[-1].vector);
	    if((yyvsp[-4].vector.dimen = j) == 0 && sm_verbose > 0) {
	       msg_1s("Vector %s has no elements\n",yyvsp[-6].charval);
	    }
	    if(vec_realloc(&yyvsp[-4].vector,yyvsp[-4].vector.dimen) < 0) {
	       msg_1s("Can't reclaim storage for %s\n",yyvsp[-6].charval);
	       free_vector(yyvsp[-6].charval);
	       break;
	    }
	    (void)copy_vector(yyvsp[-6].charval,yyvsp[-4].vector);
	 ;
    break;}
case 102:
/* #line 1048 "control.y" */
{
	    int dimension,		/* dimension of vector */
		i;
	    VECTOR *temp;		/* store address of vector */

	    dimension = (yyvsp[-1].floatval - yyvsp[-3].floatval)/yyvsp[0].floatval + 1.0001;
	    if(dimension <= 0) {
	       msg_1s("Vector %s ",yyvsp[-5].charval);
	       msg_1d("has dimension %d <= 0\n",dimension);
	       break;
            } else {
#if defined(__BORLANDC__)
	       int max_dimen = 16380;
#else
	       int max_dimen = 10000000;
#endif
	       if(dimension > max_dimen) { /* That must be wrong */
		  msg_1s("Vector %s ",yyvsp[-5].charval);
		  msg_1d("has dimension %d ",dimension);
		  msg_1d("> %d\n",max_dimen);
		  break;
	       }
	    }
	    if((temp = make_vector(yyvsp[-5].charval,dimension,VEC_FLOAT)) != NULL) {
	       for(i = 0;i < dimension;i++) {
		  temp->vec.f[i] = yyvsp[-3].floatval + i*yyvsp[0].floatval;
	       }
	    }
	 ;
    break;}
case 103:
/* #line 1078 "control.y" */
{
	    VECTOR *x;

	    if((x = get_vector_ptr(yyvsp[-5].charval)) == NULL) {
	       vec_free(&yyvsp[-3].vector); vec_free(&yyvsp[0].vector);
	       break;
	    }
	    vec_subscript(x,&yyvsp[-3].vector,&yyvsp[0].vector);
	 ;
    break;}
case 104:
/* #line 1088 "control.y" */
{
	    int c;
	    
	    if((c = input()) != ' ') unput(c);
	    if(sm_verbose > 3) msg("Just the place for a snark!\n");
	    if(recurse_lvl == 0) {
	       break;
	    }
	    if(sm_interrupt && recurse_lvl > 1) {	/* keep on popping */
	       int save_interrupt = sm_interrupt;
	       sm_interrupt = 0;
	       start_line();		/* start a new line in tokens.c */
	       push("SNARK ",S_TEMP);
	       sm_interrupt = save_interrupt;
	    }
	    recurse_lvl--;
	    return(1);
	 ;
    break;}
case 105:
/* #line 1107 "control.y" */
{
	    int dimen = 0,
	    	i,k,nvec,
	        n_float = 0,		/* number of float vectors */
	        n_string = 0,		/* number of string vectors */
		*sorted;		/* sorted indices */
	    VECTOR *temp[10];
	    VECTOR temp_f,temp_s;	/* temp vectors for rearranging */

	    if((nvec = yyvsp[0].t_list->nitem) > 10) {
	       msg("Sorry, I can only sort 10 vectors\n");
	       nvec = 10;
	    } else if(nvec == 0) {
	       freelist(yyvsp[0].t_list);
	    }

	    for(i = 0;i < nvec && !sm_interrupt;i++) {	/* get vectors */
	       if((temp[i] = get_vector_ptr(yyvsp[0].t_list->i_list[i])) == NULL) {
		  break;
	       }
	       if(temp[i]->type == VEC_FLOAT) {
		  n_float++;
	       } else if(temp[i]->type == VEC_STRING) {
		  n_string++;
	       } else {
		  msg_1d("Unknown vector type: %d",temp[i]->type);
		  msg_1s(" for vector %s\n",temp[i]->name);
	       }
	       if(i == 0) {
		  dimen = temp[0]->dimen;
	       } else if(temp[i]->dimen != dimen) {
		  msg("Vectors are different sizes\n");
		  break;
	       }
	    }
            freelist(yyvsp[0].t_list);
	    if(i < nvec) {
	       break;
	    }

	    if((sorted = (int *)malloc((unsigned)dimen*sizeof(int))) == NULL) {
	       msg("malloc returns NULL for SORT\n");
	       break;
	    }
	    if(n_float > 0) {
	       temp_f.type = VEC_FLOAT;
	       if(vec_malloc(&temp_f,dimen) == -1) {
		  msg("malloc returns NULL for SORT\n");
		  free((char *)sorted);
		  break;
	       }
	    }
	    if(n_string > 0) {
	       temp_s.type = VEC_STRING;
	       if(vec_malloc(&temp_s,dimen) == -1) {
		  msg("malloc returns NULL for SORT\n");
		  free((char *)sorted);
		  vec_free(&temp_f);
		  break;
	       }
	    }
	    if(temp[0]->type == VEC_FLOAT) {
	       sort_flt_inds(temp[0]->vec.f,sorted,dimen);
	    } else if(temp[0]->type == VEC_STRING) {
	       sort_str_inds(temp[0]->vec.s.s,sorted,dimen);
	    } else {
	       msg("You can't get here. SORT.\n");
	    }

	    for(k = 0;!sm_interrupt && k < nvec;k++) {	/* for each vector */
	       if(temp[k]->type == VEC_FLOAT) {
		  (void)memcpy((Void *)temp_f.vec.f,
			     (Const Void *)temp[k]->vec.f,dimen*sizeof(float));

		  for(i = 0;i < dimen;i++) {		/* restore it sorted */
		     temp[k]->vec.f[i] = temp_f.vec.f[sorted[i]];
		  }
	       } else {
		  (void)memcpy((Void *)temp_s.vec.s.s_s,
			  (Const Void *)temp[k]->vec.s.s_s,dimen*VEC_STR_SIZE);

		  for(i = 0;i < dimen;i++) {		/* restore it sorted */
		     strcpy(temp[k]->vec.s.s[i],temp_s.vec.s.s[sorted[i]]);
		  }
	       }
	    }

	    free((char *)sorted);
	    if(n_float > 0) vec_free(&temp_f);
	    if(n_string > 0) vec_free(&temp_s);
	 ;
    break;}
case 106:
/* #line 1199 "control.y" */
{ (void)spline(yyvsp[-3].charval,yyvsp[-2].charval,yyvsp[-1].charval,yyvsp[0].charval); ;
    break;}
case 107:
/* #line 1201 "control.y" */
{ sm_ticksize( yyvsp[-3].floatval, yyvsp[-2].floatval, yyvsp[-1].floatval, yyvsp[0].floatval); ;
    break;}
case 108:
/* #line 1203 "control.y" */
{ (void)set_term_type(yyvsp[-1].charval,yyvsp[0].intval); ;
    break;}
case 109:
/* #line 1205 "control.y" */
{
	    if(yyvsp[0].floatval < 0) {
#if defined(YYDEBUG)
	       yydebug = 1 - yydebug;	/* toggle yydebug */
#endif
	       yyvsp[0].floatval = -yyvsp[0].floatval;
	    }
	    sm_verbose = yyvsp[0].floatval;
	 ;
    break;}
case 110:
/* #line 1215 "control.y" */
{ version(); ;
    break;}
case 111:
/* #line 1217 "control.y" */
{ sm_set_viewpoint(yyvsp[-2].floatval,yyvsp[-1].floatval,yyvsp[0].floatval); ;
    break;}
case 112:
/* #line 1219 "control.y" */
{ sm_window( (int)yyvsp[-3].floatval, (int)yyvsp[-2].floatval, (int)yyvsp[-1].floatval, (int)yyvsp[0].floatval ); ;
    break;}
case 113:
/* #line 1221 "control.y" */
{
            if(execute(yyvsp[0].charval) == 0) {	/* it's a macro */
	       start_line();		/* start a new line in tokens.c */
	       if(sm_verbose > 2) msg_1s(">> macro : %s\n",yyvsp[0].charval);
	    } else {
	       if(!strcmp(yyvsp[0].charval,"\n")) {	/* probably in quotes by mistake */
		  msg("\"\\n\" is not a valid macro\n");
		  in_quote = noexpand = 0;
		  YYERROR;
	       } else {
		  if(get_macro("macro_error_handler",(int *)NULL) == NULL) {
		     msg_1s("%s is not a macro\n",yyvsp[0].charval);
		  } else {
		     static char name[60];
		     strcpy(name,yyvsp[0].charval);
		     push(name,S_NORMAL);
		     push("macro_error_handler NOT_FOUND ",S_NORMAL);
		     if(sm_verbose > 2) {
			msg_1s(">> WORD : %s\n",name);
			msg(">> macro : macro_error_handler NOT_FOUND\n");
		     }
		     (void)yyparse();
		     push("\n",S_NORMAL);
		  }
	       }
	       break;
	    }
         ;
    break;}
case 114:
/* #line 1250 "control.y" */
{ (void)read_history_macro(yyvsp[0].charval); ;
    break;}
case 115:
/* #line 1252 "control.y" */
{
	    (void)mgets(buff,MACROSIZE);
	    msg_1s("%s\n",&buff[*buff == '\0' ? 0 : 1]); /* skip ' ' */
         ;
    break;}
case 116:
/* #line 1257 "control.y" */
{
	    static char file[80] = "";	/* name of file */
	    FILE *fil;

	    (void)mgets(buff,MACROSIZE);
	    if(yyvsp[-1].intval == '+') {		/* treat file as old and append */
	       (void)strcpy(file,yyvsp[0].charval);
	    }
	    if(strcmp(file,yyvsp[0].charval) == 0) {	/* append to old file */
	       if((fil = fopen(file,"a")) == NULL) {
		  msg_1s("Can't reopen %s\n",file);
		  break;
	       }
	    } else {
	       if((fil = fopen(yyvsp[0].charval,"w")) == NULL) {
		  fprintf(stderr,"Can't open %s\n",yyvsp[0].charval);
		  break;
	       }
	       (void)strcpy(file,yyvsp[0].charval);
	    }
	    fprintf(fil,"%s\n",&buff[1]);	/* skip ' ' */
	    fclose(fil);
         ;
    break;}
case 117:
/* #line 1283 "control.y" */
{
	    if((yyval.t_list = getlist((TOK_LIST *)NULL)) == NULL) {
	       break;
	    }
	    (void)strncpy(yyval.t_list->i_list[yyval.t_list->nitem++],yyvsp[0].charval,CHARMAX);
	 ;
    break;}
case 118:
/* #line 1290 "control.y" */
{
	    if((yyval.t_list = getlist((TOK_LIST *)NULL)) == NULL) {
	       break;
	    }
	    (void)strncpy(yyval.t_list->i_list[yyval.t_list->nitem++],yyvsp[0].charval,CHARMAX);
	 ;
    break;}
case 119:
/* #line 1297 "control.y" */
{
	    if(yyvsp[-2].t_list == NULL) {		/* couldn't get space */
	       yyval.t_list = NULL;
	       break;
	    }
            if(yyvsp[-2].t_list->nitem >= yyvsp[-2].t_list->nmax) {	/* get some more space */
	       yyval.t_list = getlist(yyvsp[-2].t_list);
	    } else {
	       yyval.t_list = yyvsp[-2].t_list;
	    }
	    (void)strncpy(yyval.t_list->i_list[yyval.t_list->nitem++],yyvsp[0].charval,CHARMAX);
	 ;
    break;}
case 120:
/* #line 1310 "control.y" */
{
	    if(yyvsp[-2].t_list == NULL) {		/* couldn't get space */
	       yyval.t_list = NULL;
	       break;
	    }
            if(yyvsp[-2].t_list->nitem >= yyvsp[-2].t_list->nmax) {	/* get some more space */
	       yyval.t_list = getlist(yyvsp[-2].t_list);
	    } else {
	       yyval.t_list = yyvsp[-2].t_list;
	    }
	    (void)strncpy(yyval.t_list->i_list[yyval.t_list->nitem++],yyvsp[0].charval,CHARMAX);
	 ;
    break;}
case 121:
/* #line 1325 "control.y" */
{
	    int i,j,
	        type;			/* type of vector */

	    if(yyvsp[0].t_list == NULL) break;
	    if(num_or_word(yyvsp[0].t_list->i_list[0]) == 0) {
	       type = VEC_STRING;
	    } else {
	       type = VEC_FLOAT;
	    }
	    if(make_anon_vector(&yyval.vector,yyvsp[0].t_list->nitem,type) != 0) {
	       yyval.vector.type = VEC_NULL;
	       j = 0;
	    } else {
	       for(i = j = 0;i < yyvsp[0].t_list->nitem;i++) {
		  if(yyvsp[0].t_list->i_list[i][0] == '\n' && yyvsp[0].t_list->i_list[i][1] == '\0') {
		     continue;			/* skip \n */
		  }
		  if(type == VEC_FLOAT) {
		     yyval.vector.vec.f[j++] = atof2(yyvsp[0].t_list->i_list[i]);
		  } else {
		     (void)strncpy(yyval.vector.vec.s.s[j++],yyvsp[0].t_list->i_list[i],VEC_STR_SIZE);
		  }
	       }
	    }
	    yyval.vector.dimen = j;		/* don't bother to realloc storage */
            freelist(yyvsp[0].t_list);
	 ;
    break;}
case 122:
/* #line 1354 "control.y" */
{ vec_concat(&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 123:
/* #line 1356 "control.y" */
{
	    if(get_vector(yyvsp[0].charval,&yyval.vector) < 0) {
	       break;
	    }
	 ;
    break;}
case 124:
/* #line 1362 "control.y" */
{
	    if(make_anon_vector(&yyval.vector,1,VEC_STRING) == 0) {
	       (void)strncpy(yyval.vector.vec.s.s[0],yyvsp[0].charval,VEC_STR_SIZE);
	    } else {
	       yyval.vector.type = VEC_NULL;
	    }
	 ;
    break;}
case 125:
/* #line 1370 "control.y" */
{
	    char *temp;
	    int i,narg;

	    buff[0] = '\0';
	    for(i = 0;i < yyvsp[-1].t_list->nitem;i++) {
	       (void)strcat(buff," ");
	       (void)strcat(buff,yyvsp[-1].t_list->i_list[i]);
	    }
	    freelist(yyvsp[-1].t_list);

	    if(get_macro(yyvsp[-3].charval,&narg) == NULL) {
	       msg_1s("Macro %s is not defined\n",yyvsp[-3].charval);
	       yyval.vector.type = VEC_NULL;
	       yyval.vector.name = "(undefined())";
	       yyval.vector.dimen = 0;
	       break;
	    } else if((narg < 10 && narg != i) || (narg>= 10 && i > narg%10)) {
	       msg_2s("Macro %s expects %s",yyvsp[-3].charval,narg >= 10 ? "<= " : "");
	       msg_1d("%d arguments, ",narg%10);
	       msg_1d("%d provided\n",i);
	       yyval.vector.type = VEC_NULL; yyval.vector.dimen = 0;
	       yyval.vector.name = "(macro())";
	       break;
	    }
	    if((temp = malloc(200)) == NULL) {
	       msg_1s("Can't allocate space for %s()\n",yyvsp[-3].charval);
	       yyval.vector.type = VEC_NULL; yyval.vector.dimen = 0;
	       yyval.vector.name = "(macro())";
	       break;
	    }
	    (void)sprintf(temp,"%s %s\nSNARK ",yyvsp[-3].charval,buff);
	    push(temp,S_TEMP);
	    recurse_lvl++;
	    yyparse();			/* execute macro _now_ */
	    if((i = get_vector(yyvsp[-3].charval,&yyval.vector)) < 0) {
	       break;
	    }
	    free_vector(yyvsp[-3].charval);
	 ;
    break;}
case 126:
/* #line 1411 "control.y" */
{
	    int i,j;
	    VECTOR *temp;

	    if(yyvsp[-1].vector.type == VEC_STRING) {
	       msg_1s("Vector %s is not arithmetic\n",yyvsp[-1].vector.name);
	       yyval.vector.type = VEC_NULL;
	       yyval.vector.name = "(undefined[])";
	       yyval.vector.dimen = 0;
	       vec_free(&yyvsp[-1].vector);
	       break;
	    }
	    if((temp = get_vector_ptr(yyvsp[-3].charval)) == NULL ||
			make_anon_vector(&yyval.vector,yyvsp[-1].vector.dimen,temp->type) != 0) {
	       yyval.vector.type = VEC_NULL;
	       yyval.vector.name = "(undefined[])";
	       yyval.vector.dimen = 0;
	       vec_free(&yyvsp[-1].vector);
	       break;
	    }

	    for(j = 0;j < yyvsp[-1].vector.dimen;j++) {
	       i = (int)yyvsp[-1].vector.vec.f[j];
	       if(i >= 0 && i < temp->dimen) {
		  if(temp->type == VEC_FLOAT) {
		     yyval.vector.vec.f[j] = temp->vec.f[i];
		  } else {
		     strcpy(yyval.vector.vec.s.s[j],temp->vec.s.s[i]);
		  }
	       } else {
		  msg_1d("Subscript %d ",i);
		  msg_1s("for %s is out of range ",yyvsp[-3].charval);
		  msg_1d("[0,%d]\n",temp->dimen-1);
		  if(yyval.vector.type == VEC_STRING) {
		     yyval.vector.vec.s.s[j][0] = '\0';
		  } else {
		     yyval.vector.vec.f[j] = 0;
		  }
	       }
	    }
	    vec_free(&yyvsp[-1].vector);
	 ;
    break;}
case 127:
/* #line 1454 "control.y" */
{ yyval.vector = yyvsp[-1].vector; ;
    break;}
case 128:
/* #line 1456 "control.y" */
{
	    VECTOR zero;		/* scalar with value 0 */

	    (void)vec_value(&zero,0.0);	/* set value of zero */
	    vec_subtract(&zero,&yyvsp[0].vector,&yyval.vector);
	 ;
    break;}
case 129:
/* #line 1463 "control.y" */
{ vec_ternary(&yyvsp[-4].vector,&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 130:
/* #line 1465 "control.y" */
{ vec_abs(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 131:
/* #line 1467 "control.y" */
{ vec_acos(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 132:
/* #line 1469 "control.y" */
{ vec_asin(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 133:
/* #line 1471 "control.y" */
{ vec_atan(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 134:
/* #line 1473 "control.y" */
{ vec_atan2(&yyvsp[-3].vector,&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 135:
/* #line 1475 "control.y" */
{ vec_cos(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 136:
/* #line 1477 "control.y" */
{ vec_exp(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 137:
/* #line 1479 "control.y" */
{ vec_add(&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 138:
/* #line 1481 "control.y" */
{ vec_subtract(&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 139:
/* #line 1483 "control.y" */
{ vec_multiply(&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 140:
/* #line 1485 "control.y" */
{ vec_divide(&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 141:
/* #line 1487 "control.y" */
{ vec_power(&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 142:
/* #line 1489 "control.y" */
{ vec_eq(&yyvsp[-3].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 143:
/* #line 1491 "control.y" */
{
	    VECTOR zero;		/* scalar with value 0 */

	    (void)vec_value(&zero,0.0);	/* set value of zero */
	    vec_eq(&zero,&yyvsp[0].vector,&yyval.vector);
	 ;
    break;}
case 144:
/* #line 1498 "control.y" */
{ vec_ne(&yyvsp[-3].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 145:
/* #line 1500 "control.y" */
{ vec_and(&yyvsp[-3].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 146:
/* #line 1502 "control.y" */
{ vec_or(&yyvsp[-3].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 147:
/* #line 1504 "control.y" */
{ vec_gt(&yyvsp[-2].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 148:
/* #line 1506 "control.y" */
{ vec_ge(&yyvsp[-3].vector,&yyvsp[0].vector,&yyval.vector); ;
    break;}
case 149:
/* #line 1508 "control.y" */
{ vec_gt(&yyvsp[0].vector,&yyvsp[-2].vector,&yyval.vector); ;
    break;}
case 150:
/* #line 1510 "control.y" */
{ vec_ge(&yyvsp[0].vector,&yyvsp[-3].vector,&yyval.vector); ;
    break;}
case 151:
/* #line 1512 "control.y" */
{ vec_hist(&yyvsp[-3].vector,&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 152:
/* #line 1514 "control.y" */
{ vec_interp(&yyvsp[-3].vector,&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 153:
/* #line 1516 "control.y" */
{ vec_index(&yyvsp[-3].vector,&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 154:
/* #line 1518 "control.y" */
{ vec_int(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 155:
/* #line 1520 "control.y" */
{ vec_length(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 156:
/* #line 1522 "control.y" */
{ vec_lg(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 157:
/* #line 1524 "control.y" */
{ vec_ln(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 158:
/* #line 1526 "control.y" */
{ (void)vec_value(&yyval.vector,yyvsp[0].floatval); ;
    break;}
case 159:
/* #line 1528 "control.y" */
{ (void)vec_value(&yyval.vector,Pi); ;
    break;}
case 160:
/* #line 1530 "control.y" */
{ vec_random((int)yyvsp[-1].floatval,&yyval.vector); ;
    break;}
case 161:
/* #line 1532 "control.y" */
{ vec_sin(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 162:
/* #line 1534 "control.y" */
{ vec_sprintf(&yyvsp[-3].vector,&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 163:
/* #line 1536 "control.y" */
{ vec_sqrt(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 164:
/* #line 1538 "control.y" */
{ vec_string(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 165:
/* #line 1540 "control.y" */
{ vec_strlen(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 166:
/* #line 1542 "control.y" */
{ vec_substr(&yyvsp[-5].vector,&yyvsp[-3].vector,&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 167:
/* #line 1544 "control.y" */
{ vec_tan(&yyvsp[-1].vector,&yyval.vector); ;
    break;}
case 168:
/* #line 1548 "control.y" */
{ yyval.t_list = yyvsp[-1].t_list; ;
    break;}
case 169:
/* #line 1550 "control.y" */
{ yyval.t_list = yyvsp[-1].t_list; ;
    break;}
case 170:
/* #line 1554 "control.y" */
{ yyval.strval = yyvsp[-1].strval; ;
    break;}
case 171:
/* #line 1556 "control.y" */
{ yyval.strval = yyvsp[-1].strval; ;
    break;}
case 172:
/* #line 1560 "control.y" */
{ yyval.intval = 1; ;
    break;}
case 173:
/* #line 1562 "control.y" */
{ yyval.intval = 2; ;
    break;}
case 174:
/* #line 1566 "control.y" */
{ yyval.t_list = yyvsp[-1].t_list; ;
    break;}
case 175:
/* #line 1568 "control.y" */
{ yyval.t_list = yyvsp[0].t_list; ;
    break;}
case 176:
/* #line 1573 "control.y" */
{ (void)sm_axis( yyvsp[-8].floatval, yyvsp[-7].floatval, yyvsp[-6].floatval, yyvsp[-5].floatval, yyvsp[-4].intval, yyvsp[-3].intval, yyvsp[-2].intval, yyvsp[-1].intval, yyvsp[0].intval ); ;
    break;}
case 177:
/* #line 1575 "control.y" */
{ vec_axis( yyvsp[-8].floatval, yyvsp[-7].floatval, &yyvsp[-6].vector, &yyvsp[-5].vector, (VECTOR *)NULL, yyvsp[-4].intval, yyvsp[-3].intval, yyvsp[-2].intval, yyvsp[-1].intval, yyvsp[0].intval ); ;
    break;}
case 178:
/* #line 1578 "control.y" */
{
	    VECTOR *lab;
	    
	    if((lab = get_vector_ptr(yyvsp[-5].charval)) == NULL) {
	       break;
	    }
	    if(lab->type != VEC_STRING) {
	       msg_1s("Error: %s is not a string vector\n",yyvsp[-5].charval);
	       YYERROR;
	    }
	    if(lab->dimen != yyvsp[-6].vector.dimen && lab->dimen != 1) {
	       msg_2s("The dimensions of %s and %s must be the same\n",
		      yyvsp[-6].vector.name,yyvsp[-5].charval);
	       YYERROR;
	    }
	    vec_axis( yyvsp[-9].floatval, yyvsp[-8].floatval, &yyvsp[-7].vector, &yyvsp[-6].vector, lab, yyvsp[-4].intval, yyvsp[-3].intval, yyvsp[-2].intval, yyvsp[-1].intval, yyvsp[0].intval );
	 ;
    break;}
case 179:
/* #line 1596 "control.y" */
{ sm_box(1,2,0,0); ;
    break;}
case 180:
/* #line 1598 "control.y" */
{ sm_box(yyvsp[-1].intval,yyvsp[0].intval,0,0); ;
    break;}
case 181:
/* #line 1600 "control.y" */
{ sm_box(yyvsp[-3].intval,yyvsp[-2].intval,yyvsp[-1].intval,yyvsp[0].intval); ;
    break;}
case 182:
/* #line 1602 "control.y" */
{ (void)sm_contour(); ;
    break;}
case 183:
/* #line 1604 "control.y" */
{
	    set_color(&yyvsp[0].vector);
	    vec_free(&yyvsp[0].vector);
	 ;
    break;}
case 184:
/* #line 1609 "control.y" */
{ int_color(yyvsp[0].intval); ;
    break;}
case 185:
/* #line 1611 "control.y" */
{ sm_ctype(yyvsp[0].charval); ;
    break;}
case 186:
/* #line 1613 "control.y" */
{
	    sm_cursor(0);
            (void)unput('\n');
	 ;
    break;}
case 187:
/* #line 1618 "control.y" */
{ set_cursor_vectors(yyvsp[-1].charval,yyvsp[0].charval); ;
    break;}
case 188:
/* #line 1620 "control.y" */
{ sm_dot(); ;
    break;}
case 189:
/* #line 1622 "control.y" */
{ sm_draw(yyvsp[-1].floatval,yyvsp[0].floatval); ;
    break;}
case 190:
/* #line 1624 "control.y" */
{ gdraw(yyvsp[-2].floatval,yyvsp[-1].floatval); ;
    break;}
case 191:
/* #line 1626 "control.y" */
{ (*devices[devnum].dev_erase)(); ;
    break;}
case 192:
/* #line 1628 "control.y" */
{
	    float *temp = NULL;
	    int i,npoint;

	     if(yyvsp[-3].vector.dimen < yyvsp[-2].vector.dimen) {
	        msg_2s("%s contains fewer points than %s\n",yyvsp[-3].vector.name,yyvsp[-2].vector.name);
	        npoint = yyvsp[-3].vector.dimen;
	     } else if(yyvsp[-2].vector.dimen < yyvsp[-3].vector.dimen) {
	        msg_2s("%s contains fewer points than %s\n",yyvsp[-2].vector.name,yyvsp[-3].vector.name);
	        npoint = yyvsp[-2].vector.dimen;
	     } else {
	        npoint = yyvsp[-3].vector.dimen;
	     }

	     if(yyvsp[-1].vector.dimen == 1) {
		if((temp = (float *)malloc((unsigned)npoint*sizeof(float)))
								== NULL) {
		   msg("Can't allocate space in errorbar\n");
		   vec_free(&yyvsp[-3].vector); vec_free(&yyvsp[-2].vector); vec_free(&yyvsp[-1].vector);
		   break;
		}
		for(i = 0;i < npoint;i++) {
		   temp[i] = yyvsp[-1].vector.vec.f[0];
		}
		free((char *)(yyvsp[-1].vector.vec.f));
		yyvsp[-1].vector.vec.f = temp;
	     } else if(yyvsp[-1].vector.dimen < npoint) {
		msg_2s("%s is smaller than %s ",yyvsp[-1].vector.name,yyvsp[-3].vector.name);
		msg_1s("or %s, truncating\n",yyvsp[-2].vector.name);
		npoint = yyvsp[-1].vector.dimen;
	     } else if(yyvsp[-1].vector.dimen > npoint) {
		msg_2s("%s is larger than %s ",yyvsp[-1].vector.name,yyvsp[-3].vector.name);
		msg_1s("or %s\n",yyvsp[-2].vector.name);
	     }

	     (void)sm_errorbar(yyvsp[-3].vector.vec.f,yyvsp[-2].vector.vec.f,yyvsp[-1].vector.vec.f,yyvsp[0].intval,npoint);
	     vec_free(&yyvsp[-3].vector); vec_free(&yyvsp[-2].vector); vec_free(&yyvsp[-1].vector);
	  ;
    break;}
case 193:
/* #line 1667 "control.y" */
{ sm_grid(yyvsp[-1].intval,yyvsp[0].intval); ;
    break;}
case 194:
/* #line 1669 "control.y" */
{
	    if(*mgets(buff,MACROSIZE) != '\0') {
	       sm_label(&buff[1]);
	    } else {
	       msg("Can't get label\n");
	    }
	 ;
    break;}
case 195:
/* #line 1677 "control.y" */
{ sm_ltype( (int)yyvsp[0].floatval ); ;
    break;}
case 196:
/* #line 1679 "control.y" */
{ sm_ltype( 10 ); ;
    break;}
case 197:
/* #line 1681 "control.y" */
{ (*devices[devnum].dev_page)(); ;
    break;}
case 198:
/* #line 1683 "control.y" */
{
	    int npoint;

	    if(yyvsp[-1].vector.dimen < yyvsp[0].vector.dimen) {
	       msg_2s("%s contains fewer points than %s\n",yyvsp[-1].vector.name,yyvsp[0].vector.name);
	       npoint = yyvsp[-1].vector.dimen;
	    } else if(yyvsp[0].vector.dimen < yyvsp[-1].vector.dimen) {	
	       msg_2s("%s contains fewer points than %s\n",yyvsp[0].vector.name,yyvsp[-1].vector.name);
	       npoint = yyvsp[0].vector.dimen;
	    } else {
	       npoint = yyvsp[-1].vector.dimen;
	    }

	    if(yyvsp[-2].intval == CONNECT) {
	       (void)sm_conn( yyvsp[-1].vector.vec.f, yyvsp[0].vector.vec.f, npoint );
	    } else if(yyvsp[-2].intval == HISTOGRAM) {
	       (void)sm_histogram( yyvsp[-1].vector.vec.f, yyvsp[0].vector.vec.f, npoint );
	    } else if(yyvsp[-2].intval == POINTS) {
	       sm_points( yyvsp[-1].vector.vec.f, yyvsp[0].vector.vec.f, npoint );
	    } else {
	       msg("Unknown plotting command\n");
	    }
	    vec_free(&yyvsp[-1].vector); vec_free(&yyvsp[0].vector);
	 ;
    break;}
case 199:
/* #line 1708 "control.y" */
{
	    int npoint;

	    if(yyvsp[-5].vector.dimen < yyvsp[-4].vector.dimen) {
	       msg_2s("%s contains fewer points than %s\n",yyvsp[-5].vector.name,yyvsp[-4].vector.name);
	       npoint = yyvsp[-5].vector.dimen;
	    } else if(yyvsp[-4].vector.dimen < yyvsp[-5].vector.dimen) {
	       msg_2s("%s contains fewer points than %s\n",yyvsp[-4].vector.name,yyvsp[-5].vector.name);
	       npoint = yyvsp[-4].vector.dimen;
	    } else {
	       npoint = yyvsp[-5].vector.dimen;
	    }

	    if(yyvsp[-1].vector.dimen != npoint) {
	       msg("Logical vector differs in length from data\n");
	       if(npoint > yyvsp[-1].vector.dimen) {
		  npoint = yyvsp[-1].vector.dimen;
	       }
	    }

	    if(yyvsp[-6].intval == CONNECT) {
	       (void)conn_if( yyvsp[-5].vector.vec.f, yyvsp[-4].vector.vec.f, yyvsp[-1].vector.vec.f, npoint );
	    } else if(yyvsp[-6].intval == HISTOGRAM) {
	       (void)histogram_if( yyvsp[-5].vector.vec.f, yyvsp[-4].vector.vec.f, yyvsp[-1].vector.vec.f, npoint );
	    } else if(yyvsp[-6].intval == POINTS) {
	       points_if( yyvsp[-5].vector.vec.f, yyvsp[-4].vector.vec.f, yyvsp[-1].vector.vec.f, npoint );
	    } else {
	       msg("Unknown plotting command\n");
	    }
	    vec_free(&yyvsp[-1].vector); vec_free(&yyvsp[-5].vector); vec_free(&yyvsp[-4].vector);
	 ;
    break;}
case 200:
/* #line 1740 "control.y" */
{
	    if(*mgets(buff,MACROSIZE) != '\0') {
	       sm_putlabel(yyvsp[0].intval,&buff[1]);
	    } else {
	       msg("Can't get label\n");
	    }
	  ;
    break;}
case 201:
/* #line 1748 "control.y" */
{ sm_relocate(yyvsp[-1].floatval,yyvsp[0].floatval); ;
    break;}
case 202:
/* #line 1750 "control.y" */
{ sm_grelocate(yyvsp[-2].floatval,yyvsp[-1].floatval); ;
    break;}
case 203:
/* #line 1752 "control.y" */
{
	    int npoint;

	    npoint = yyvsp[-1].vector.dimen;
	    if(npoint != yyvsp[0].vector.dimen) {
	       msg("dimension of vectors in shade must be equal\n");
	       npoint = (npoint < yyvsp[0].vector.dimen) ? npoint : yyvsp[0].vector.dimen;
	    }
	    if(yyvsp[-3].intval == 1) {
	       (void)sm_shade(yyvsp[-2].intval,yyvsp[-1].vector.vec.f,yyvsp[0].vector.vec.f,npoint);
	    } else if(yyvsp[-3].intval == 2) {
	       (void)shade_hist(yyvsp[-2].intval,yyvsp[-1].vector.vec.f,yyvsp[0].vector.vec.f,npoint);
	    } else {
	       msg("Unknown shading command\n");
	    }
	    vec_free(&yyvsp[-1].vector); vec_free(&yyvsp[0].vector);
	 ;
    break;}
case 204:
/* #line 1770 "control.y" */
{ sm_draw_surface(yyvsp[-2].intval,yyvsp[-1].floatval,yyvsp[0].floatval,(float *)NULL,0,(float *)NULL,0); ;
    break;}
case 205:
/* #line 1772 "control.y" */
{
	    VECTOR *x,*y;
	    
	    if((x = get_vector_ptr(yyvsp[-1].charval)) == NULL) {
	       break;
	    }
	    if(x->type != VEC_FLOAT) {
	       msg_1s("Error: %s is not an arithmetic vector\n",yyvsp[-1].charval);
	       YYERROR;
	    }
	    if((y = get_vector_ptr(yyvsp[0].charval)) == NULL) {
	       break;
	    }
	    if(y->type != VEC_FLOAT) {
	       msg_1s("Error: %s is not an arithmetic vector\n",yyvsp[0].charval);
	       YYERROR;
	    }
	    sm_draw_surface(yyvsp[-4].intval,yyvsp[-3].floatval,yyvsp[-2].floatval,x->vec.f,x->dimen,y->vec.f,y->dimen);
	 ;
    break;}
case 206:
/* #line 1792 "control.y" */
{
	    char *ptr;
	    if((ptr = mgets(word,CHARMAX)) == NULL || *ptr == '\0') {
	       ptr = "USER ABORT";
	    } else {
	       ptr++;			/* skip initial space */
	    }
	    start_line();
	    msg_1s("%s\n",ptr);
	    save_str("<user abort>");
	    YYERROR;
	 ;
    break;}
case 207:
/* #line 1805 "control.y" */
{
	     word[1] = '\0';
	     if(mgets(word,CHARMAX) != NULL) {
	        userfn(&yyvsp[0].intval,&word[1]);
	     }
	  ;
    break;}
case 208:
/* #line 1812 "control.y" */
{
	    if(*mgets(buff,MACROSIZE) != '\0') {
	       sm_xlabel(&buff[1]);
	    } else {
	       msg("Can't get xlabel\n");
	    }
	 ;
    break;}
case 209:
/* #line 1820 "control.y" */
{
	    if(*mgets(buff,MACROSIZE) != '\0') {
	       sm_ylabel(&buff[1]);
	    } else {
	       msg("Can't get ylabel\n");
	    }
	 ;
    break;}
case 210:
/* #line 1830 "control.y" */
{ yyval.intval = yyvsp[0].intval; ;
    break;}
case 211:
/* #line 1832 "control.y" */
{ yyval.intval = -yyvsp[0].intval; ;
    break;}
case 212:
/* #line 1836 "control.y" */
{ yyval.intval = yyvsp[0].intval; ;
    break;}
case 213:
/* #line 1838 "control.y" */
{ yyval.intval = 0; ;
    break;}
case 214:
/* #line 1842 "control.y" */
{
	    int i;
	    float diff,min,max;

	    if(fabs(x_range) < 1e-20 && fabs(y_range) < 1e-20) {
	       min = 1e30; max = -1e30;
	       for(i = 0;i < yyvsp[0].vector.dimen;i++) {
	          if(yyvsp[0].vector.vec.f[i] < NO_VALUE) { /* not a bad point */
		     if(yyvsp[0].vector.vec.f[i] > max) {
		        max = yyvsp[0].vector.vec.f[i];
		     }
		     if(yyvsp[0].vector.vec.f[i] < min) {
		        min = yyvsp[0].vector.vec.f[i];
		     }
		  }
	       }
	    } else {			/* a range is set for x and/or y */
	       sort_flt(yyvsp[0].vector.vec.f,yyvsp[0].vector.dimen);

	       for(i = yyvsp[0].vector.dimen - 1;i >= 0;i--) { /* ignore bad points */
	          if(yyvsp[0].vector.vec.f[i] < NO_VALUE) break;
	       }
	       if(i < 0) {
	          msg("No valid values to find limits from");
	          yyval.pairval.a = yyval.pairval.b = yyval.pairval.med = 0.0;
	          break;
	       }

	       min = yyvsp[0].vector.vec.f[0];
	       max = yyvsp[0].vector.vec.f[i];
	       if(i%2 == 0) {
	          yyval.pairval.med = yyvsp[0].vector.vec.f[i/2];
	       } else {
	          yyval.pairval.med = (yyvsp[0].vector.vec.f[i/2] + yyvsp[0].vector.vec.f[i/2 + 1])/2;
	       }
	    }
	    diff = max - min;
	    if(diff == 0) {
	       diff = min;
	    }
	    diff *= 0.05;
	    yyval.pairval.a = min - diff;
	    yyval.pairval.b = max + diff;
	    vec_free(&yyvsp[0].vector);
	 ;
    break;}
case 215:
/* #line 1888 "control.y" */
{
	    yyval.pairval.a = yyvsp[-1].floatval;
	    yyval.pairval.b = yyvsp[0].floatval;
	    yyval.pairval.med = (yyvsp[-1].floatval + yyvsp[0].floatval)/2;
	 ;
    break;}
case 216:
/* #line 1896 "control.y" */
{ yyval.t_list = getlist((TOK_LIST *)NULL); ;
    break;}
case 217:
/* #line 1898 "control.y" */
{
	    if(yyvsp[-1].t_list == NULL) {		/* couldn't get space */
	       break;
	    }
            if(yyvsp[-1].t_list->nitem >= yyvsp[-1].t_list->nmax) {	/* get some more space */
	       yyval.t_list = getlist(yyvsp[-1].t_list);
	    } else {
	       yyval.t_list = yyvsp[-1].t_list;
	    }
	    (void)strncpy(yyval.t_list->i_list[yyval.t_list->nitem],yyvsp[0].charval,CHARMAX);
	    yyval.t_list->nitem++;
	 ;
    break;}
case 218:
/* #line 1911 "control.y" */
{
	    if(yyvsp[-1].t_list == NULL) {		/* couldn't get space */
	       break;
	    }
            if(yyvsp[-1].t_list->nitem >= yyvsp[-1].t_list->nmax) {	/* get some more space */
	       yyval.t_list = getlist(yyvsp[-1].t_list);
	    } else {
	       yyval.t_list = yyvsp[-1].t_list;
	    }
	    (void)strncpy(yyval.t_list->i_list[yyval.t_list->nitem],yyvsp[0].charval,CHARMAX);
	    yyval.t_list->nitem++;
	 ;
    break;}
case 219:
/* #line 1924 "control.y" */
{
	    if(yyvsp[-1].t_list == NULL) {		/* couldn't get space */
	       break;
	    }
            if(yyvsp[-1].t_list->nitem >= yyvsp[-1].t_list->nmax) {	/* get some more space */
	       yyval.t_list = getlist(yyvsp[-1].t_list);
	    } else {
	       yyval.t_list = yyvsp[-1].t_list;
	    }
	    (void)strncpy(yyval.t_list->i_list[yyval.t_list->nitem],"\n",CHARMAX);
	    yyval.t_list->nitem++;
	 ;
    break;}
case 220:
/* #line 1939 "control.y" */
{ yyval.floatval = yyvsp[-1].intval ? -yyvsp[0].floatval : yyvsp[0].floatval; ;
    break;}
case 221:
/* #line 1941 "control.y" */
{ yyval.floatval = yyvsp[-1].intval ? -yyvsp[0].intval : yyvsp[0].intval; ;
    break;}
case 222:
/* #line 1943 "control.y" */
{ yyval.floatval = yyvsp[-1].vector.dimen; vec_free(&yyvsp[-1].vector); ;
    break;}
case 223:
/* #line 1945 "control.y" */
{
	    int i;
	    double val;			/* $$ is a float */

	    val = 0;
	    for(i = 0;i < yyvsp[-1].vector.dimen;i++) {
	       val += yyvsp[-1].vector.vec.f[i];
	    }
	    yyval.floatval = val;
	    vec_free(&yyvsp[-1].vector);
	 ;
    break;}
case 224:
/* #line 1957 "control.y" */
{
	    int i,tok;
	    YYSTYPE lval;

	    i = 0;
	    if(yyvsp[-1].charval[0] == '-') {		/* could be part of -number */
	       if(yyvsp[-1].charval[1] == '.' || isdigit(yyvsp[-1].charval[1])) {
		  i = 1;		/* assume it is, this could be wrong */
	       }
	    }
	    push(&yyvsp[-1].charval[i],S_NORMAL);
	    tok = yylex(&lval,(Void *)NULL); /* convert word to a token */
	    unsave_str();		/* yylex will have saved it */
	    if(tok == INTEGER || tok == FLOAT) {
	       i = 0;
	    } else {					/* a word */
	       i = 01;
	       if(get_macro(yyvsp[-1].charval,(int *)NULL) != NULL) i |= 02; /* a macro */
	       if(*print_var(yyvsp[-1].charval) != '\0') i |= 04;	/* a variable */
	       if(is_vector(yyvsp[-1].charval)) i |= 010;		/* a vector */
	       if(tok != WORD) i |= 020;		/* a keyword */
	    }
	    yyval.floatval = i;
	 ;
    break;}
case 225:
/* #line 1984 "control.y" */
{ (void)sprintf(yyval.charval,"%g",yyvsp[0].floatval); ;
    break;}
case 226:
/* #line 1986 "control.y" */
{ (void)strcpy(yyval.charval,yyvsp[0].charval); ;
    break;}
case 227:
/* #line 1990 "control.y" */
{ yyval.floatval = 1; ;
    break;}
case 228:
/* #line 1992 "control.y" */
{ yyval.floatval = yyvsp[0].floatval; ;
    break;}
case 229:
/* #line 1996 "control.y" */
{
	    int type;

	    if((type = get_vector(yyvsp[0].charval,&yyval.vector)) < 0) {
	       break;
	    } else if(type == VEC_STRING) {
	       msg_1s("%s is not an arithmetic vector\n",yyvsp[0].charval);
	       break;
	    }
	 ;
    break;}
case 230:
/* #line 2007 "control.y" */
{ yyval.vector = yyvsp[-1].vector; yyval.vector.name = "(expr)"; ;
    break;}
case 231:
/* #line 2011 "control.y" */
{ yyval.intval = CONNECT; ;
    break;}
case 232:
/* #line 2013 "control.y" */
{ yyval.intval = HISTOGRAM; ;
    break;}
case 233:
/* #line 2015 "control.y" */
{ yyval.intval = POINTS; ;
    break;}
case 234:
/* #line 2019 "control.y" */
{ yyval.intval = '+'; ;
    break;}
case 235:
/* #line 2021 "control.y" */
{ yyval.intval =  ' '; ;
    break;}
case 236:
/* #line 2025 "control.y" */
{
	    if((yyval.strval.start = malloc(1)) != NULL) {
	       yyval.strval.start[0] = '\0';
	       yyval.strval.end = yyval.strval.start;
	    }
	 ;
    break;}
case 237:
/* #line 2032 "control.y" */
{ yyval.strval = yyvsp[0].strval; ;
    break;}
case 238:
/* #line 2036 "control.y" */
{ yyval.intval = 1; ;
    break;}
case 239:
/* #line 2038 "control.y" */
{ yyval.intval = 0; ;
    break;}
case 240:
/* #line 2040 "control.y" */
{ yyval.intval = 0; ;
    break;}
case 241:
/* #line 2044 "control.y" */
{
	    if(yyvsp[0].vector.dimen <= 0) {
	       msg_1s("Vector %s has dimension <= 0\n",yyvsp[0].vector.name);
	       YYERROR;
	    } else if(yyvsp[0].vector.dimen != 1 && sm_verbose > 1) {
	       msg_1s("Vector %s must be a scalar\n",yyvsp[0].vector.name);
	    }
	    if(yyvsp[0].vector.type != VEC_FLOAT && sm_verbose > 1) {
	       msg_1s("Error: %s is not an arithmetic vector\n",yyvsp[0].vector.name);
	       vec_free(&yyvsp[0].vector);
	       YYERROR;
	    }
	    yyval.floatval = yyvsp[0].vector.vec.f[0];
	    vec_free(&yyvsp[0].vector);
	 ;
    break;}
case 242:
/* #line 2062 "control.y" */
{
	    char c;
	    int i;
	    
	    while(isspace(c = input())) ;
	    (void)unput(c);			/* one too far */

	    for(i = 0;i < CHARMAX - 1;) {
	       if((c = input()) != ')' && !isspace(c)) {
	          yyval.charval[i++] = c;
	       } else {
		  (void)unput(c);
		  break;
	       }
	    }
	    yyval.charval[i] = '\0';
	    if(i == 0) {
	       msg("Error: empty name\n");
	       YYERROR;
	    }
	    save_str(yyval.charval);
            if(sm_verbose > 3) {
               msg_1d("%d> WORD     ",noexpand);
               msg_1s("%s\n",yyval.charval);
	    }
	 ;
    break;}
case 243:
/* #line 2091 "control.y" */
{
	    char *ptr;			/* pointer to $$ */
	    int brace_level,		/* nesting of braces */
	        l_delim,r_delim;	/* left and right delimiters */
	    unsigned int size;		/* size allocated for $$ */

	    if((l_delim = *(yyvsp[0].charval)) == '{') {
	       r_delim = '}';
	    } else if(l_delim == '<') {
	       r_delim = '>';
	    } else {
	       msg_1d("Unknown delimiter %c\n",l_delim);
	       yyval.strval.start = NULL;
	       break;
	    }

	    size = 500;
	    if((yyval.strval.start = malloc(size + 1)) == NULL) { /* extra 1 for '\0' */
	       msg("Can't allocate storage for list\n");
	       break;
	    }

	    for(brace_level = 0,ptr = yyval.strval.start;!sm_interrupt;ptr++) {
	       *ptr = input();
	       if(*ptr == r_delim) {
		  if(brace_level == 0) {
		     break;
		  } else {
		     brace_level--;
		  }
	       } else if(*ptr == l_delim) {
		  brace_level++;
	       }
	       if(ptr >= yyval.strval.start + size - 1) {
		  size *= 2;
		  if((yyval.strval.start = realloc(yyval.strval.start,size + 1)) == NULL) {
		     msg("Can't reallocate storage for do loop\n");
		     goto failed;
		  }
		  ptr = yyval.strval.start + size/2 - 1;
	       }
	    }
	    yyval.strval.end = ptr;
	    *(yyval.strval.end) = '\n';
	    *(yyval.strval.end + 1) = '\0';

	    (void)unput(r_delim);
	    save_str("(str_list)");
	    if(sm_verbose > 3) {
	       if(sm_verbose > 4) {
		  msg_1d("%d> (str_list :\n",noexpand);
		  msg_1s("\t%s",yyval.strval.start);
	       } else {
		  msg_1d("%d> (str_list)\n",noexpand);
	       }
	    }
	    break;
	    failed: ;			/* break out after failed realloc */
	 ;
    break;}
case 244:
/* #line 2152 "control.y" */
{
	    char *ptr,*str;
	    
	    str = yyvsp[0].charval; str++;		/* strip opening ' */
	    for(ptr = yyval.charval;*str != '\0';) {
	       if(*str == '\\') {
		  str++;
		  switch (*str) {
		   case '\\': *ptr++ = '\\'; break;
		   case '\'': *ptr++ = '\''; break;
		   case 'n': *ptr++ = '\n'; break;
		   case 'r': *ptr++ = '\r'; break;
		   case 't': *ptr++ = '\t'; break;
		   default:
		     msg_1d("Unknown escape sequence in format: \\%c\n",*str);
		     *ptr++ = *str;
		     break;
		  }
		  if(*str != '\0') str++;
	       } else {
		  *ptr++ = *str++;
	       }
	    }
	    *(ptr - 1) = '\0';		/* strip closing ' */
	 ;
    break;}
case 245:
/* #line 2180 "control.y" */
{ yyval.charval[0] = '\0'; ;
    break;}
case 246:
/* #line 2182 "control.y" */
{ (void)strcpy(yyval.charval,yyvsp[0].charval); ;
    break;}
case 247:
/* #line 2186 "control.y" */
{
	    char c;
	    int i;
	    
	    while(isspace(c = input())) ;
	    (void)unput(c);			/* one too far */

	    for(i = 0;i < CHARMAX - 1;) {
	       if((c = input()) == '_' || isalnum(c)) {
	          yyval.charval[i++] = c;
	       } else {
		  (void)unput(c);
		  break;
	       }
	    }
	    yyval.charval[i] = '\0';
	    if(i == 0) {
	       msg("Error: empty variable name\n");
	       YYERROR;
	    }
	    save_str(yyval.charval);
            if(sm_verbose > 3) {
               msg_1d("%d> WORD     ",noexpand);
               msg_1s("%s\n",yyval.charval);
	    }
	 ;
    break;}
case 248:
/* #line 2215 "control.y" */
{ yyval.charval[0] = '\0'; ;
    break;}
case 249:
/* #line 2217 "control.y" */
{ (void)strcpy(yyval.charval,yyvsp[0].charval); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
/* #line 303 "bison.simple" */

  yyvsp -= yylen;
  yylsp -= yylen;
  yyssp -= yylen;

  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now: %d", yyssp-yyss);
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }

  *++yyvsp = yyval;

  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      yyerror("parse error");
    }

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYERROR;

      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYERROR;
  yyvsp--;
  yylsp--;
  yystate = *--yyssp;

  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now: %d", yyssp-yyss);
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  if (yydebug)
    fprintf(stderr, "Shifting error token, ");

  *++yyvsp = yylval;
  *++yylsp = yylloc;

  yystate = yyn;
  goto yynewstate;
}
/* #line 2220 "control.y" */
					/* start of programmes */

void
yyerror(s)
char s[];
{
   char *cmacro,			/* which macro are we in? */
	*lline;				/* pointer to last line */
   int i,
       offset;				/* offset of last token in line */

   if(strcmp(s,"syntax error") != 0 &&			/* Yacc message */
		 	strcmp(s,"parse error") != 0 &&	/* Bison message */
		 	strcmp(s,"misc error") != 0 &&	/* our message */
		 	strcmp(s,"show where") != 0) {	/* display command */
      msg_1s("%s in control.y\n",s);
   } else {				/* Syntax Error */
      if(graph_mode) { IDLE(); graph_mode = 0; }
      lline = get_line(&offset);
      if(!strcmp(s,"misc error")) {	/* a private (not yacc) message */
	 fprintf(stderr,"Error at \"%s\"",&lline[offset]);
      } else if(!strcmp(s,"show where")) { /* just print current command */
	 if(!sm_verbose) {
	    fprintf(stderr,"\n");
	    return;
	 }
	 fprintf(stderr," at \"%s\"",&lline[offset]);
      } else if(strcmp(lline,"<user abort>") == 0) { /* a deliberate error */
	 if(*print_var("traceback") != '\0') {
	    dump_stack();
	 }
	 return;
      } else {
	 fprintf(stderr,"Syntax error at \"%s\"",&lline[offset]);
      }
      if((cmacro = current_macro()) == NULL) {
	 fprintf(stderr,"\n");
      } else {
	 fprintf(stderr," in macro %s\n",cmacro);
      }
      fprintf(stderr,"%s\n",lline);
      for(i = 0;i < offset;i++) (void)putc(' ',stderr);
      while(lline[i++] != '\0') (void)putc('^',stderr);
      (void)putc('\n',stderr);
      if(*print_var("traceback") != '\0') {
	 dump_stack();
      }
      if(in_graphics) { ENABLE(); graph_mode = 1; }
   }
}

/****************************************************/
/*
 * Print a string on stdout, after dealing with graph mode
 */
void
msg(fmt)
char *fmt;			/* message to print */
{
   if(graph_mode) { IDLE(); graph_mode = 0; }
   printf(fmt); fflush(stdout);
   if(in_graphics) { ENABLE(); graph_mode = 1; }
}

/*
 * Print a string on stdout, with one string argument
 */
void
msg_1s(fmt,s)
char *fmt,			/* message to print */
     *s;
{
   if(graph_mode) { IDLE(); graph_mode = 0; }
   printf(fmt,s); fflush(stdout);
   if(in_graphics) { ENABLE(); graph_mode = 1; }
}


/*
 * Print a string on stdout, with two string arguments
 */
void
msg_2s(fmt,s1,s2)
char *fmt,			/* message to print */
     *s1,*s2;
{
   if(graph_mode) { IDLE(); graph_mode = 0; }
   printf(fmt,s1,s2); fflush(stdout);
   if(in_graphics) { ENABLE(); graph_mode = 1; }
}

/*
 * Print a string on stdout, with one int argument
 */
void
msg_1d(fmt,i)
char *fmt;			/* message to print */
int i;
{
   if(graph_mode) { IDLE(); graph_mode = 0; }
   printf(fmt,i); fflush(stdout);
   if(in_graphics) { ENABLE(); graph_mode = 1; }
}

/*
 * Print a string on stdout, with one float argument
 */
void
msg_1f(fmt,x)
char *fmt;			/* message to print */
float x;
{
   if(graph_mode) { IDLE(); graph_mode = 0; }
   printf(fmt,x); fflush(stdout);
   if(in_graphics) { ENABLE(); graph_mode = 1; }
}

/*
 * Parse a qualifer: e.g. `2.s' -> VEC_STRING
 */
int
parse_qualifier(str)
char *str;
{
   char *ptr;
   
   if((ptr = strrchr(str,'.')) == NULL) {
      return(VEC_FLOAT);
   } else {
      switch (*(ptr + 1)) {
       case 'f':
	 return(VEC_FLOAT);
       case 's':
	 return(VEC_STRING);
       default:
	 msg_1s("unknown type qualifier: %s\n",str);
	 return(VEC_FLOAT);
      }
   }
}
